ORG &6BE0
	;MODE 1
	LD A,1
	CALL &BC0E

	;border noir
	LD bc,0
	CALL &BC38

	;*** ECRAN PRS 1 ***
	CALL encrenoires
	CALL cacher_ecran
	LD HL,&7D0	;donnees
	LD DE,&C000	;destination
	CALL DECOMPECRAN
	CALL montrer_ecran
	CALL ecran1

	;*** ECRAN PRS 2 ***
	CALL encrenoires
	CALL cacher_ecran
	LD HL,&1864	;donnees
	LD DE,&C000	;destination
	CALL DECOMPECRAN
	CALL montrer_ecran
	CALL ecran2

	;*** ECRAN PRS 3 ***
	CALL encrenoires
	CALL cacher_ecran
	LD HL,&236C	;donnees
	LD DE,&C000	;destination
	CALL DECOMPECRAN
	CALL montrer_ecran
	CALL ecran3

	;*** ECRAN PRS 4 ***
	CALL encrenoires
	CALL cacher_ecran
	LD HL,&360B	;donnees
	LD DE,&C000	;destination
	CALL DECOMPECRAN
	CALL montrer_ecran
	CALL ecran4

	;*** ECRAN PRS 5 ***
	CALL encrenoires
	CALL cacher_ecran
	LD HL,&4A27	;donnees
	LD DE,&C000	;destination
	CALL DECOMPECRAN
	;Souci - Derniere ligne mangee a la compression du coup on voit la ligne de l'image precedente
	;supprimer les &50 octets de la derniere ligne
	LD HL,&FF80
	LD DE,&FF81
	LD BC,&4F
	LD (HL),0
	LDIR
	CALL montrer_ecran
	CALL ecran5

	;*** ECRAN PRS 6 ***
	CALL encrenoires
	CALL cacher_ecran
	LD HL,&6095	;donnees
	LD DE,&C000	;destination
	CALL DECOMPECRAN
	CALL montrer_ecran
	CALL ecran6

	;FIN retour au basic
	CALL &BB6C	;CLS

	RET

.encrenoires
	CALL &BD19	; Ralentir pour eviter que ca saute a l'ecran
	LD BC,#7F00	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops
	LD BC,#7F02	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops
	LD BC,#7F03	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops
	ret


.Sauver
	DW #0000

.cacher_ecran
	LD BC,&BC06
	out (c),c
	LD BC,&BD00
	out (c),c
	RET	

.montrer_ecran
	LD BC,&BC06
	out (c),c
	LD BC,&BD00+25
	out (c),c
	RET


;----------------------------------------------------------------------------
;--- ECRAN 1 ---
;---------------
.ecran1
	XOR a
	LD bc,0
	CALL &BC32

	LD a,1
	LD bc,&0202
	CALL &BC32

	LD a,2
	LD bc,&0606
	CALL &BC32

	LD a,3
	LD bc,&1A1A
	CALL &BC32

	DI		; Desactiver les interruptions
	LD HL,(&38) 	; Lire l'ancienne interruption
	LD (Sauver),HL 	; Sauvegarder la valeur 16 bits
	LD HL,&C9FB 	; Registre 16 bits EI (&FB) + RET (&C9)
	LD (&38),HL 	; Ecrire en &0038 et &0039 le contenu du registre HL
	EI 		; Interruption autorisees


	;encre 0 - Noir
	LD BC,#7F00	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 1 - Bleu
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&55        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 2 - Rouge
	LD BC,#7F02	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4C        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 3 - Blanc
	LD BC,#7F03	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4B        ; 2 nops
	OUT (c),a       ; 4 nops

.loop

	LD B,&F5 	; Se connecter au PPI/8255 port B accessible via &F5xx
.Balayage
	IN A,(C) 	; Lire le contenu
	RRA 		; On teste si le bit 0 = 1
	JP nc,Balayage 	; Si le bit 0 = 0 on boucle jusqu'a la fin du balayage
			; On est en haut de l'ecran, on peut continuer le programme

	;encre 2
	LD BC,&7F02	; 3 nops
	OUT (c),c	; 4 nops

	HALT 		; Attendre interruption 1
	;HALT 		; Attendre interruption 2

	; Position vertical (140 coin haut gauche)
	;+8 pour ligne graphique suivante
	;+64 pour ligne texte suivante
	LD BC,140+64+64+64+64+64+8+8
.WaitLoop
	NOP		; 1 nop
	DEC BC		; 2 nops
	LD A,B		; 1 nop
	OR C		; 1 nops
	JR NZ,WaitLoop	; 3 nops, TOTAL 8 nops


	; split colors
	LD b,&4C	; rouge vif par defaut (2 nops)
	LD c,&4D	; magenta vif (2 nops)
	LD h,&53	; turquoise vif (2 nops)
	LD l,&4A	; jaune vif (2 nops)
	LD d,&52	; vert vif (2 nops)
	LD e,&4E	; Orange
	;DEFS 1,0

	DI		; 1 nop

	; Position horizontal (40 colonne, 1 nop par colonne)
	DEFS 2,0

;SPLIT-RASTERS 1
	LD a,29	;nombre de ligne graphique
		splitrasterligne1:
		OUT (c),b  ;couleur d'origine (4 nops)
		OUT (c),c  ; 4 nops
		DEFS 2,0
		OUT (c),h  ; 4 nops
		DEFS 1,0
		OUT (c),b  ; couleur d'origine (4 nops)
		DEFS 41,0
		;total 60 NOPS

		DEC a	; 1 nop
	jr nz,splitrasterligne1	;3 nops

	;8 lignes
	LD a,80
.decalage1
	DEFS 4,0		;4 nop
	DEC a			;1 nop
	JP nz,decalage1		;3 nops

;SPLIT-RASTERS 2
	LD a,24	;nombre de ligne graphique
		splitrasterligne2:
		OUT (c),b  ;couleur d'origine (4 nops)
		DEFS 19,0
		OUT (c),e  ; 4 nops
		DEFS 2,0
		OUT (c),b  ; couleur d'origine (4 nops)
		DEFS 27,0
		;total 60 NOPS

		DEC a	; 1 nop
	jr nz,splitrasterligne2	;3 nops

	;8 lignes
	LD a,38
.decalage2
	DEFS 4,0		;4 nops
	DEC a			;1 nop
	JP nz,decalage2		;3 nops

	DEFS 6,0


;SPLIT RASTERS 3

	LD a,78	;nombre de ligne graphique
		splitrasterligne3:
		OUT (c),b  ;couleur d'origine (4 nops)
		DEFS 2,0
		OUT (c),l  ; 4 nops
		DEFS 2,0
		OUT (c),h  ; 4 nops
		DEFS 1,0
		OUT (c),b  ; couleur d'origine (4 nops)
		DEFS 4,0
		OUT (c),d  ; 4 nops
		DEFS 31,0
		;total 60 NOPS

		DEC a	; 1 nop
	jr nz,splitrasterligne3	;3 nops

	OUT (c),b  ; couleur d'origine (4 nops)

	EI		; 1 nop



; Test touche
.Touche
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F645	;ligne 5
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche ESPACE)
JR NC,Sortir1
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F649	;ligne 9
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche DEL)
	RLA		;Charge dans A la valeur du bit 6 (touche JOY_FIRE0)
	RLA		;Charge dans A la valeur du bit 5 (touche JOY_FIRE1 Z)
	RLA		;Charge dans A la valeur du bit 4 (touche JOY_FIRE2 X)
	JP C,loop	;Si TIR du joystick n'a pas etait enfonce on boucle

.Sortir1
	DI 		; Desactiver les interruptions
	LD HL,(Sauver) 	; Restauration des anciennes interruptions
	LD (&38),hl 	; Ecrire
	EI 		; Interruption autorisees
	RET

;----------------------------------------------------------------------------
;--- ECRAN 2 ---
;---------------
.ecran2
	XOR a
	LD bc,0
	CALL &BC32

	LD a,1
	LD bc,&0202
	CALL &BC32

	LD a,2
	LD bc,&1818
	CALL &BC32

	LD a,3
	LD bc,&1A1A
	CALL &BC32

	DI		; Desactiver les interruptions
	LD HL,(&38) 	; Lire l'ancienne interruption
	LD (Sauver),HL 	; Sauvegarder la valeur 16 bits
	LD HL,&C9FB 	; Registre 16 bits EI (&FB) + RET (&C9)
	LD (&38),HL 	; Ecrire en &0038 et &0039 le contenu du registre HL
	EI 		; Interruption autorisees

	;encre 0 - Noir
	LD BC,#7F00	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 1 - Bleu
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&55        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 2 - Jaune
	LD BC,#7F02	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4A        ; 2 nops
	OUT (c),a

	;encre 3 - Blanc
	LD BC,#7F03	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4B        ; 2 nops
	OUT (c),a       ; 4 nops

.loop2


	LD B,&F5 	; Se connecter au PPI/8255 port B accessible via &F5xx
.Balayage2
	IN A,(C) 	; Lire le contenu
	RRA 		; On teste si le bit 0 = 1
	JP nc,Balayage2	; Si le bit 0 = 0 on boucle jusqu'a la fin du balayage
			; On est en haut de l'ecran, on peut continuer le programme

	HALT 		; Attendre interruption 1
	HALT 		; Attendre interruption 2

	; Position vertical (140 coin haut gauche)
	;+8 pour ligne graphique suivante
	;+64 pour ligne texte suivante
	LD BC,140+64+64+64+64
.WaitLoop2
	NOP		; 1 nop
	DEC BC		; 2 nops
	LD A,B		; 1 nop
	OR C		; 1 nops
	JR NZ,WaitLoop2	; 3 nops, TOTAL 8 nops

	;encre 2
	LD BC,#7F02	; 3 nops
	OUT (c),c	; 4 nops

	; split colors
	LD b,&4A	; Jaune vif par defaut (2 nops)
	LD c,&5B	; Bleu pastel (2 nops)

	DI		; 1 nop

	; Position horizontal (40 colonne, 1 nop par colonne)
	DEFS 6,0

	LD a,18	;nombre de ligne graphique
		splitrasterligne21:
		OUT (c),b  ;couleur d'origine (4 nops)
		DEFS 5,0
		OUT (c),c  ; 4 nops
		OUT (c),b  ;couleur d'origine (4 nops)
		DEFS 43,0
		;total 60 NOPS

		DEC a	; 1 nop
	jr nz,splitrasterligne21	;3 nops

	EI		; 1 nop



; Test touche
.Touche2
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F645	;ligne 5
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche ESPACE)
JR NC,Sortir2
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F649	;ligne 9
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche DEL)
	RLA		;Charge dans A la valeur du bit 6 (touche JOY_FIRE0)
	RLA		;Charge dans A la valeur du bit 5 (touche JOY_FIRE1 Z)
	RLA		;Charge dans A la valeur du bit 4 (touche JOY_FIRE2 X)
	JP C,loop2	;Si TIR du joystick n'a pas etait enfonce on boucle

.Sortir2
	DI 		; Desactiver les interruptions
	LD HL,(Sauver) 	; Restauration des anciennes interruptions
	LD (&38),hl 	; Ecrire
	EI 		; Interruption autorisees
	RET

;----------------------------------------------------------------------------
;--- ECRAN 3 ---
;---------------
.ecran3
	XOR a
	LD bc,0
	CALL &BC32

	LD a,1
	LD bc,&0202
	CALL &BC32

	LD a,2
	LD bc,&0606
	CALL &BC32

	LD a,3
	LD bc,&1A1A
	CALL &BC32

	DI		; Desactiver les interruptions
	LD HL,(&38) 	; Lire l'ancienne interruption
	LD (Sauver),HL 	; Sauvegarder la valeur 16 bits
	LD HL,&C9FB 	; Registre 16 bits EI (&FB) + RET (&C9)
	LD (&38),HL 	; Ecrire en &0038 et &0039 le contenu du registre HL
	EI 		; Interruption autorisees

	;encre 0 - Noir
	LD BC,#7F00	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 1 - Bleu
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&55        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 2 - Rouge
	LD BC,#7F02	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4C        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 3 - Blanc
	LD BC,#7F03	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4B        ; 2 nops
	OUT (c),a       ; 4 nops

.loop3

	;encre 1
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops

	LD B,&F5 	; Se connecter au PPI/8255 port B accessible via &F5xx
.Balayage3
	IN A,(C) 	; Lire le contenu
	RRA 		; On teste si le bit 0 = 1
	JP nc,Balayage3	; Si le bit 0 = 0 on boucle jusqu'a la fin du balayage
			; On est en haut de l'ecran, on peut continuer le programme

	HALT 		; Attendre interruption 1
	HALT 		; Attendre interruption 2

	; Position vertical (140 coin haut gauche)
	;+8 pour ligne graphique suivante
	;+64 pour ligne texte suivante
	LD BC,140+64+64+64+8+8+8+8+8
.WaitLoop3
	NOP		; 1 nop
	DEC BC		; 2 nops
	LD A,B		; 1 nop
	OR C		; 1 nops
	JR NZ,WaitLoop3	; 3 nops, TOTAL 8 nops


	; split colors
	LD b,&55	; bleu vif par defaut (2 nops)
	LD c,&53	; turquoise vif (2 nops)
	LD h,&4A	; jaune vif (2 nops)
	LD l,&4E	; Orange
	DEFS 8,0

	DI		; 1 nop

	; Position horizontal (40 colonne, 1 nop par colonne)
	DEFS 2,0

;SPLIT-RASTERS 1
	LD a,64	;nombre de ligne graphique
		splitrasterligne31:
		OUT (c),b  ;couleur d'origine (4 nops)
		DEFS 20,0
		OUT (c),c  ; 4 nops
		DEFS 4,0
		;OUT (c),b  ;couleur d'origine (4 nops)
		OUT (c),h  ; 4 nops
		DEFS 4,0
		DEFS 2,0
		OUT (c),b  ;couleur d'origine (4 nops)
		DEFS 14,0
		;total 60 NOPS

		DEC a	; 1 nop
	jr nz,splitrasterligne31	;3 nops

;SPLIT-RASTERS 2
	LD a,53	;nombre de ligne graphique
		splitrasterligne32:
		OUT (c),l  ; 4 nops
		DEFS 8,0
		OUT (c),b  ;couleur d'origine (4 nops)
		DEFS 7,0
		OUT (c),c  ; 4 nops
		DEFS 4,0
		OUT (c),b  ;couleur d'origine (4 nops)
		DEFS 10,0
		DEFS 15,0
		;total 60 NOPS

		DEC a	; 1 nop
	jr nz,splitrasterligne32	;3 nops

	;resynchroniser
	OUT (c),l  ; 4 nops
	DEFS 24
	OUT (c),b  ;couleur d'origine (4 nops)
	DEFS 31,0

;SPLIT-RASTERS 3
	LD a,54	;nombre de ligne graphique
		splitrasterligne33:
		OUT (c),l  ; 4 nops
		DEFS 23,0
		OUT (c),b  ;couleur d'origine (4 nops)
		DEFS 9,0
		DEFS 20,0
		;total 60 NOPS

		DEC a	; 1 nop
	jr nz,splitrasterligne33	;3 nops

	EI		; 1 nop



; Test touche
.Touche3
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F645	;ligne 5
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche ESPACE)
JR NC,Sortir3
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F649	;ligne 9
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche DEL)
	RLA		;Charge dans A la valeur du bit 6 (touche JOY_FIRE0)
	RLA		;Charge dans A la valeur du bit 5 (touche JOY_FIRE1 Z)
	RLA		;Charge dans A la valeur du bit 4 (touche JOY_FIRE2 X)
	JP C,loop3	;Si TIR du joystick n'a pas etait enfonce on boucle

.Sortir3
	DI 		; Desactiver les interruptions
	LD HL,(Sauver) 	; Restauration des anciennes interruptions
	LD (&38),hl 	; Ecrire
	EI 		; Interruption autorisees
	RET

;----------------------------------------------------------------------------
;--- ECRAN 4 ---
;---------------
.ecran4
	XOR a
	LD bc,0
	CALL &BC32

	LD a,1
	LD bc,&0606
	CALL &BC32

	LD a,2
	LD bc,&1414
	CALL &BC32

	LD a,3
	LD bc,&1A1A
	CALL &BC32

	DI		; Desactiver les interruptions
	LD HL,(&38) 	; Lire l'ancienne interruption
	LD (Sauver),HL 	; Sauvegarder la valeur 16 bits
	LD HL,&C9FB 	; Registre 16 bits EI (&FB) + RET (&C9)
	LD (&38),HL 	; Ecrire en &0038 et &0039 le contenu du registre HL
	EI 		; Interruption autorisees

	;encre 0 - Noir
	LD BC,#7F00	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 1 - Rouge
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4C        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 2 - Turquoise vif
	LD BC,#7F02	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&53        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 3 - Blanc
	LD BC,#7F03	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4B        ; 2 nops
	OUT (c),a       ; 4 no

.loop4

	;encre 2
	LD BC,#7F02	; 3 nops
	OUT (c),c	; 4 nops

	LD B,&F5 	; Se connecter au PPI/8255 port B accessible via &F5xx
.Balayage4
	IN A,(C) 	; Lire le contenu
	RRA 		; On teste si le bit 0 = 1
	JP nc,Balayage4	; Si le bit 0 = 0 on boucle jusqu'a la fin du balayage
			; On est en haut de l'ecran, on peut continuer le programme

	HALT 		; Attendre interruption 1
	HALT 		; Attendre interruption 2

	; Position vertical (140 coin haut gauche)
	;+8 pour ligne graphique suivante
	;+64 pour ligne texte suivante
	LD BC,140
.WaitLoop4
	NOP		; 1 nop
	DEC BC		; 2 nops
	LD A,B		; 1 nop
	OR C		; 1 nops
	JR NZ,WaitLoop4	; 3 nops, TOTAL 8 nops


	; split colors
	LD b,&53	; turquoise vif par defaut (2 nops)
	LD c,&5C	; rouge fonce (2 nops)
	LD h,&55	; bleu vif (2 nops)
	LD l,&58	; magenta (2 nops)

;	LD d,&57	; bleu ciel (2 nops)
	LD d,&4D	;magenta vif

	LD e,&4A	; jaune vif (2 nops)
	DEFS 4,0

	DI		; 1 nop

	; Position horizontal (40 colonne, 1 nop par colonne)
	DEFS 4,0

;SPLIT-RASTERS 1
	LD a,16	;nombre de ligne graphique
		splitrasterligne41:
		OUT (c),b  ;couleur d'origine (4 nops)
		DEFS 6,0
		OUT (c),c  ; 4 nops
		DEFS 10,0
		OUT (c),d  ;couleur d'origine (4 nops)
		DEFS 12,0
		OUT (c),b  ;couleur d'origine (4 nops)
		OUT (c),h  ; 4 nops
		DEFS 12,0
		;total 60 NOPS

		DEC a	; 1 nop
	jr nz,splitrasterligne41	;3 nops

;SPLIT-RASTERS 2
	LD a,88	;nombre de ligne graphique
		splitrasterligne42:
		OUT (c),h  ; 4 nops
		DEFS 6,0
		OUT (c),b  ;couleur d'origine (4 nops)
		DEFS 9,0
		OUT (c),d  ; 4 nops
		DEFS 12,0
		OUT (c),b  ;couleur d'origine (4 nops)
		OUT (c),h  ; 4 nops
		DEFS 13,0
		;total 60 NOPS

		DEC a	; 1 nop
	jr nz,splitrasterligne42	;3 nops

;SPLIT-RASTERS 3
	LD a,40	;nombre de ligne graphique
		splitrasterligne43:
		OUT (c),h  ; 4 nops
		DEFS 5,0
		OUT (c),b  ;couleur d'origine (4 nops)
		DEFS 11,0
		OUT (c),l  ; 4 nops
		OUT (c),b  ;couleur d'origine (4 nops)
		OUT (c),h  ; 4 nops		
		DEFS 24,0
		;total 60 NOPS

		DEC a	; 1 nop
	jr nz,splitrasterligne43	;3 nops

	;on remplit tout le bas
	OUT (c),e

	EI		; 1 nop



; Test touche
.Touche4
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F645	;ligne 5
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche ESPACE)
JR NC,Sortir4
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F649	;ligne 9
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche DEL)
	RLA		;Charge dans A la valeur du bit 6 (touche JOY_FIRE0)
	RLA		;Charge dans A la valeur du bit 5 (touche JOY_FIRE1 Z)
	RLA		;Charge dans A la valeur du bit 4 (touche JOY_FIRE2 X)
	JP C,loop4	;Si TIR du joystick n'a pas etait enfonce on boucle

.Sortir4
	DI 		; Desactiver les interruptions
	LD HL,(Sauver) 	; Restauration des anciennes interruptions
	LD (&38),hl 	; Ecrire
	EI 		; Interruption autorisees
	RET

;----------------------------------------------------------------------------
;--- ECRAN 5 ---
;---------------
.ecran5
	XOR a
	LD bc,0
	CALL &BC32

	LD a,1
	LD bc,&0505
	CALL &BC32

	LD a,2
	LD bc,&0606
	CALL &BC32

	LD a,3
	LD bc,&1A1A
	CALL &BC32

	DI		; Desactiver les interruptions
	LD HL,(&38) 	; Lire l'ancienne interruption
	LD (Sauver),HL 	; Sauvegarder la valeur 16 bits
	LD HL,&C9FB 	; Registre 16 bits EI (&FB) + RET (&C9)
	LD (&38),HL 	; Ecrire en &0038 et &0039 le contenu du registre HL
	EI 		; Interruption autorisees

	;encre 0 - Noir
	LD BC,#7F00	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 1 - Mauve
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&5D        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 2 - Rouge
	LD BC,#7F02	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4C        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 3 - Blanc
	LD BC,#7F03	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4B        ; 2 nops
	OUT (c),a       ; 4 nops

.loop5


	LD B,&F5 	; Se connecter au PPI/8255 port B accessible via &F5xx
.Balayage5
	IN A,(C) 	; Lire le contenu
	RRA 		; On teste si le bit 0 = 1
	JP nc,Balayage5	; Si le bit 0 = 0 on boucle jusqu'a la fin du balayage
			; On est en haut de l'ecran, on peut continuer le programme



	HALT 		; Attendre interruption 1
	HALT 		; Attendre interruption 2


DI

	;LD BC,140+64+64+64+64+64+64+64+64
	LD BC,140
.WaitLoop5
	NOP
	DEC BC
	LD A,B
	OR C
	JR NZ,WaitLoop5

	;encre 1
	LD BC,#7F01
	OUT (c),c

	; split colors
	LD b,&5D	; Mauve par defaut (2 nops)
	LD c,&52	; vert vif (2 nops)
	LD h,&57	; bleu ciel (2 nops)
	LD l,&4A	; jaune vif (2 nops)
	LD d,&40	; gris (2 nops)
	LD e,&58	; magenta (2 nops)

	;pour caller au bon emplacement
	;DS 2,0

	LD a,96	;nombre de ligne
		splitrasterligne51:
		OUT (c),b  ;couleur d'origine (4 nops)
		DEFS 7,0
		OUT (c),c  ; 4 nops
		DEFS 1,0
		OUT (c),e  ; 4 nops
		DEFS 21,0
		OUT (c),b  ;couleur d'origine (4 nops)
		DEFS 15,0
		;total 60 NOPS

		DEC a
	jr nz,splitrasterligne51


	LD a,26	;nombre de ligne
		splitrasterligne52:
		OUT (c),b  ;couleur d'origine (4 nops)
		DEFS 7,0
		OUT (c),d  ; 4 nops
		OUT (c),h  ; 4 nops
		OUT (c),b  ;couleur d'origine (4 nops)
		DEFS 37,0
		;total 60 NOPS

		DEC a
	jr nz,splitrasterligne52

	;resynchroniser
	OUT (c),b  ;couleur d'origine (4 nops)
	DEFS 8,0
	OUT (c),d ; 4 nops
	DEFS 4,0		
	OUT (c),b  ;couleur d'origine (4 nops)
	DEFS 39,0
	;total 53 nops

	LD a,13	;nombre de ligne
		splitrasterligne53:
		OUT (c),b  ;couleur d'origine (4 nops)
		DEFS 7,0
		OUT (c),d  ; 4 nops
		DEFS 4,0
		OUT (c),b  ;couleur d'origine (4 nops)
		DEFS 33,0
		OUT (c),l ; 4 nops
		;total 60 NOPS

		DEC a
	jr nz,splitrasterligne53


	LD a,63	;nombre de ligne
		splitrasterligne54:
		OUT (c),l  ; 4 nops
		DEFS 6,0
		OUT (c),d  ; 4 nops
		DEFS 4,0
		OUT (c),l  ; 4 nops
		DEFS 17,0
		OUT (c),b  ;couleur d'origine (4 nops)
		DEFS 13,0
		OUT (c),l  ; 4 nops
		;total 60 NOPS

		DEC a
	jr nz,splitrasterligne54

	OUT (c),b  ;couleur d'origine (4 nops)

EI


; Test touche
.Touche5
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F645	;ligne 5
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche ESPACE)
JR NC,Sortir5
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F649	;ligne 9
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche DEL)
	RLA		;Charge dans A la valeur du bit 6 (touche JOY_FIRE0)
	RLA		;Charge dans A la valeur du bit 5 (touche JOY_FIRE1 Z)
	RLA		;Charge dans A la valeur du bit 4 (touche JOY_FIRE2 X)
	JP C,loop5	;Si TIR du joystick n'a pas etait enfonce on boucle

.Sortir5
	DI 		; Desactiver les interruptions
	LD HL,(Sauver) 	; Restauration des anciennes interruptions
	LD (&38),hl 	; Ecrire
	EI 		; Interruption autorisees
	RET

;----------------------------------------------------------------------------
;--- ECRAN 6 ---
;---------------
.ecran6
	XOR a
	LD bc,0
	CALL &BC32

	LD a,1
	LD bc,&0606
	CALL &BC32

	LD a,2
	LD bc,&1414
	CALL &BC32

	LD a,3
	LD bc,&1A1A
	CALL &BC32

	DI		; Desactiver les interruptions
	LD HL,(&38) 	; Lire l'ancienne interruption
	LD (Sauver),HL 	; Sauvegarder la valeur 16 bits
	LD HL,&C9FB 	; Registre 16 bits EI (&FB) + RET (&C9)
	LD (&38),HL 	; Ecrire en &0038 et &0039 le contenu du registre HL
	EI 		; Interruption autorisees

	;encre 0 - Noir
	LD BC,#7F00	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 1 - Rouge
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4C        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 2 - Turquoise vif
	LD BC,#7F02	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&53        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 3 - Blanc
	LD BC,#7F03	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4B        ; 2 nops
	OUT (c),a       ; 4 nops

.loop6

	LD B,&F5 	; Se connecter au PPI/8255 port B accessible via &F5xx
.Balayage6
	IN A,(C) 	; Lire le contenu
	RRA 		; On teste si le bit 0 = 1
	JP nc,Balayage6	; Si le bit 0 = 0 on boucle jusqu'a la fin du balayage
			; On est en haut de l'ecran, on peut continuer le programme


	HALT 		; Attendre interruption 1
	HALT 		; Attendre interruption 2

	;positionnement
	LD a,169
.decalage6
	DEFS 12,0		;4 nop
	DEC a			;1 nop
	JP nz,decalage6		;3 nops

	;ajustement
	DEFS 1

	;encre 1
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops

	LD hl,table_rasters ; 3 nops
	LD e,total_raster   ; (nb de rasters a lire) 2 nops

.lire_couleur_raster
	LD a,(hl)                 ; 2 nops
	INC hl                    ; 2 nops
	OUT (c),a                 ; 4 nops

	;synchronisation (64 nops par ligne)
	defs 64-4-2-2-1-3

	DEC e                     ; 1 nops
	JP nz,lire_couleur_raster ; 3 nops

; Test touche
.Touche6
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F645	;ligne 5
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche ESPACE)
JR NC,Sortir6
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F649	;ligne 9
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche DEL)
	RLA		;Charge dans A la valeur du bit 6 (touche JOY_FIRE0)
	RLA		;Charge dans A la valeur du bit 5 (touche JOY_FIRE1 Z)
	RLA		;Charge dans A la valeur du bit 4 (touche JOY_FIRE2 X)
	JP C,loop6	;Si TIR du joystick n'a pas etait enfonce on boucle

.Sortir6
	DI 		; Desactiver les interruptions
	LD HL,(Sauver) 	; Restauration des anciennes interruptions
	LD (&38),hl 	; Ecrire
	EI 		; Interruption autorisees
	RET

total_raster EQU 1+12+18+47+40+14+22+1

.table_rasters
;noir (1)
DEFB &54
;rouge (12)
DEFB &4C,&4C,&4C,&4C,&4C,&4C,&4C,&4C,&4C,&4C,&4C,&4C
;violet (18)
DEFB &4D,&4D,&4D,&4D,&4D,&4D,&4D,&4D,&4D,&4D,&4D,&4D
DEFB &4D,&4D,&4D,&4D,&4D,&4D
;jaune (47)
DEFB &4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A
DEFB &4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A
DEFB &4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A
DEFB &4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A
DEFB &4A,&4A,&4A,&4A,&4A,&4A,&4A
;gris (40)
DEFB &40,&40,&40,&40,&40,&40,&40,&40,&40,&40
DEFB &40,&40,&40,&40,&40,&40,&40,&40,&40,&40
DEFB &40,&40,&40,&40,&40,&40,&40,&40,&40,&40
DEFB &40,&40,&40,&40,&40,&40,&40,&40,&40,&40
;vert vif (14)
DEFB &52,&52,&52,&52,&52,&52,&52,&52,&52,&52
DEFB &52,&52,&52,&52
;bleu (22)
DEFB &55,&55,&55,&55,&55,&55,&55,&55,&55,&55
DEFB &55,&55,&55,&55,&55,&55,&55,&55,&55,&55
DEFB &55,&55
;noir (1)
DEFB &54


;00 = &54 noir
;01 = &44 bleu
;02 = &55 bleu vif
;03 = &5C rouge fonce
;04 = &58 magenta
;05 = &5D mauve
;06 = &4C rouge vif
;07 = &45 pourpre
;08 = &4D magenta vif
;09 = &56 vert
;10 = &46 turquoise
;11 = &57 bleu ciel
;12 = &5E jaune
;13 = &40 gris
;14 = &5F bleu pastel
;15 = &4E orange
;16 = &47 rose
;17 = &4F magenta pastel
;18 = &52 vert vif
;19 = &42 vert marin
;20 = &53 turquoise vif
;21 = &5A vert citron
;22 = &59 vert pastel
;23 = &5B turquoise pastel
;24 = &4A jaune vif
;25 = &43 jaune pastel
;26 = &4B blanc

;------------------------------------------------------------------------------
;list
; Aplib decrunching routine
;nolist
; (c) CNGSOFT
; En entree, on a :
; HL = implantation du code compacte
; DE = implantation du code decompacte
;------------------------------------------------------------------------------
DECOMPECRAN
	;DI
        ;LD HL,CHOIXECRAN
        ;LD DE,&C000

        CALL boot
        JP &000F

; Maxam source by T&J/GPA -  01/18/2008
; Nothing changed, except thy damned hidden opcodes
; and a new variable for Maxam ( 13+8*0 = 0 for Maxam )
; Attention, cette routine contient un assemblage conditionnel.
; Si Aplib8flag = 0, le code decompacte est ecrite du bas de la
; memoire vers le haut de la memoire. C est ce que font par defaut
; les programmes modifies par Dadman/CEZ - Team (APPACK.EXE et
; aPPackWin.exe.

; Si Aplib8flag = 1, le code decompacte est ecrit du haut de la
; memoire vers le bas de la memoire. Le code compacte doit bien
; evidemment etre organise en consequence.
aplib8flag equ &0  ; = DEC  &00 pour INC

flagdecde equ aplib8flag*8 ; for Maxam compatibility

Boot
 PUSH HL ; used for EX HL,(SP)
 PUSH HL
  POP IX
 DB &FD,&26,&80 ; LD IYh,&80
  
aplib8literal

 LD A,(IX+ &00)

 DB &DD,&23 + flagdecde ; INC IX/DEC IX
 
 LD (DE),A
 
 DB &13 + flagdecde ; INC DE/DEC DE
 DB &FD,&2E,&02       ; LD IYl,&2

aplib8nexttag

 CALL aplib8getbit
  JR NC, aplib8literal
 LD BC,&0000
 CALL aplib8getbit
 JR NC, aplib8codepair
 LD H,B
 CALL aplib8getbit
 JR NC, aplib8shortmatch
 DB &FD,&2E,&02      ; LD IYl,2
 INC C ; bc
 LD L,&10

aplib8getmorebits

 CALL aplib8getbit
 RL L
 JR NC, aplib8getmorebits
 JR NZ, aplib8domatch
  LD A,L
 LD (DE),A
 DB &13+ flagdecde ; INC DE/DEC DE
 JR aplib8nexttag

aplib8codepair
 
 CALL aplib8getgamma
  DB &FD,&4D  ; LD C,IYl
 SBC HL,BC
  JR NZ, aplib8normalcodepair
 CALL aplib8getgamma
  LD B,H
 JR aplib8domatch_lastpos

aplib8normalcodepair

 DEC L
 LD H,L
  LD L,(IX + &00)
 DB &DD,&23+ flagdecde ; INC IX/DEC IX
  PUSH HL
 CALL aplib8getgamma
 LD B,H
  POP HL
 LD A,H
 CP 125 ; cmp eax,32000
  JR NC, aplib8domatch_with_2inc
 CP &05
  JR NC, aplib8domatch_with_inc
 AND A
  JR NZ, aplib8domatch_new_lastpos
 LD A,L
  ADD A
 JR C, aplib8domatch_new_lastpos

aplib8domatch_with_2inc 

 INC BC
 
aplib8domatch_with_inc

 INC BC
aplib8domatch_new_lastpos

 EX (SP),HL
 
aplib8domatch_lastpos

 POP HL
 PUSH HL
  DB &FD,&2E,&01  ; LD IYl,1

aplib8domatch

if aplib8flag ; LDIR/LDDR

  ADD HL,DE
   LDDR
else
 AND A
  EX DE,HL
   SBC HL,DE
   EX DE,HL
   ADD HL,DE
 EX DE,HL
  LDIR
endif
 JR aplib8nexttag

aplib8shortmatch

 LD L,(IX+&00)
 DB &DD,&23+ flagdecde ; INC IX/DEC IX
  SRL L
 JR Z, aplib8donedepacking
  RL C
 JR aplib8domatch_with_2inc

aplib8getbit

 DB &FD,&7C ; LD A,IYh
 ADD A
  JR NZ,aplib8getbit_
  LD A,(IX + &00)
 DB &DD,&23+ flagdecde ; INC IX/DEC IX
  ADC A

aplib8getbit_

 DB &FD,&67 ; LD  IYh,A
 RET

aplib8getgamma

 LD HL,&0001
 
aplib8getgamma_ 
 CALL aplib8getbit
 ADC HL,HL
  CALL aplib8getbit
 JR C, aplib8getgamma_
  LD C,L
 RET

aplib8donedepacking

 POP HL ; used for EX HL,(SP)
 PUSH IX
  POP HL
 RET ; Warning, A might not be 0!