ORG &8000
WRITE DIRECT "ECRAN5.BIN"

	LD bc,0
	CALL &BC38

;ECRAN 2
	XOR a
	LD bc,0
	CALL &BC32

	LD a,1
	LD bc,&0505
	CALL &BC32

	LD a,2
	LD bc,&0606
	CALL &BC32

	LD a,3
	LD bc,&1A1A
	CALL &BC32

	DI		; Desactiver les interruptions
	LD HL,(&38) 	; Lire l'ancienne interruption
	LD (Sauver),HL 	; Sauvegarder la valeur 16 bits
	LD HL,&C9FB 	; Registre 16 bits EI (&FB) + RET (&C9)
	LD (&38),HL 	; Ecrire en &0038 et &0039 le contenu du registre HL
	EI 		; Interruption autorisees

.loop


	LD B,&F5 	; Se connecter au PPI/8255 port B accessible via &F5xx
.Balayage
	IN A,(C) 	; Lire le contenu
	RRA 		; On teste si le bit 0 = 1
	JP nc,Balayage 	; Si le bit 0 = 0 on boucle jusqu'a la fin du balayage
			; On est en haut de l'ecran, on peut continuer le programme



	HALT 		; Attendre interruption 1
	HALT 		; Attendre interruption 2





DI

	;LD BC,140+64+64+64+64+64+64+64+64
	LD BC,140
.WaitLoop
	NOP
	DEC BC
	LD A,B
	OR C
	JR NZ,WaitLoop

	;encre 1
	LD BC,#7F01
	OUT (c),c

	; split colors
	LD b,&5D	; Mauve par defaut (2 nops)
	LD c,&52	; vert vif (2 nops)
	LD h,&57	; bleu ciel (2 nops)
	LD l,&4A	; jaune vif (2 nops)
	LD d,&40	; gris (2 nops)
	LD e,&58	; magenta (2 nops)

	;pour caller au bon emplacement
	;DS 2,0

	;LD a,32	;nombre de ligne
	;	splitrasterligne1:
	;	OUT (c),b  ;couleur d'origine (4 nops)
	;	DEFS 7,0
	;	OUT (c),c  ; 4 nops
	;	DEFS 1,0
	;	OUT (c),b  ;couleur d'origine (4 nops)
	;	DEFS 40,0
		;total 60 NOPS

	;	DEC a
	;jr nz,splitrasterligne1

	LD a,96	;nombre de ligne
		splitrasterligne1:
		OUT (c),b  ;couleur d'origine (4 nops)
		DEFS 7,0
		OUT (c),c  ; 4 nops
		DEFS 1,0
		OUT (c),e  ; 4 nops
		DEFS 21,0
		OUT (c),b  ;couleur d'origine (4 nops)
		DEFS 15,0
		;total 60 NOPS

		DEC a
	jr nz,splitrasterligne1


	LD a,26	;nombre de ligne
		splitrasterligne2:
		OUT (c),b  ;couleur d'origine (4 nops)
		DEFS 7,0
		OUT (c),d  ; 4 nops
		OUT (c),h  ; 4 nops
		OUT (c),b  ;couleur d'origine (4 nops)
		DEFS 37,0
		;total 60 NOPS

		DEC a
	jr nz,splitrasterligne2

	;resynchroniser
	OUT (c),b  ;couleur d'origine (4 nops)
	DEFS 8,0
	OUT (c),d ; 4 nops
	DEFS 4,0		
	OUT (c),b  ;couleur d'origine (4 nops)
	DEFS 39,0
	;total 53 nops

	LD a,13	;nombre de ligne
		splitrasterligne3:
		OUT (c),b  ;couleur d'origine (4 nops)
		DEFS 7,0
		OUT (c),d  ; 4 nops
		DEFS 4,0
		OUT (c),b  ;couleur d'origine (4 nops)
		DEFS 33,0
		OUT (c),l ; 4 nops
		;total 60 NOPS

		DEC a
	jr nz,splitrasterligne3


	LD a,64	;nombre de ligne
		splitrasterligne4:
		OUT (c),l  ; 4 nops
		DEFS 6,0
		OUT (c),d  ; 4 nops
		DEFS 4,0
		OUT (c),l  ; 4 nops
		DEFS 17,0
		OUT (c),b  ;couleur d'origine (4 nops)
		DEFS 13,0
		OUT (c),l  ; 4 nops
		;total 60 NOPS

		DEC a
	jr nz,splitrasterligne4

	OUT (c),b  ;couleur d'origine (4 nops)

EI


; Test touche
.Touche
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F645	;ligne 5
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche ESPACE)
JR NC,Sortir
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F649	;ligne 9
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche DEL)
	RLA		;Charge dans A la valeur du bit 6 (touche JOY_FIRE0)
	RLA		;Charge dans A la valeur du bit 5 (touche JOY_FIRE1 Z)
	RLA		;Charge dans A la valeur du bit 4 (touche JOY_FIRE2 X)
	JP C,loop	;Si TIR du joystick n'a pas etait enfonce on boucle



.Sortir
	;retour au BASIC
	DI 		; Desactiver les interruptions
	LD HL,(Sauver) 	; Restauration des anciennes interruptions
	LD (&38),hl 	; Ecrire
	EI 		; Interruption autorisees
	RET

.Sauver
	DW #0000

;00 = &54 noir
;01 = &44 bleu
;02 = &55 bleu vif
;03 = &5C rouge fonce
;04 = &58 magenta
;05 = &5D mauve
;06 = &4C rouge vif
;07 = &45 pourpre
;08 = &4D magenta vif
;09 = &56 vert
;10 = &46 turquoise
;11 = &57 bleu ciel
;12 = &5E jaune
;13 = &40 gris
;14 = &5F bleu pastel
;15 = &4E orange
;16 = &47 rose
;17 = &4F magenta pastel
;18 = &52 vert vif
;19 = &42 vert marin
;20 = &53 turquoise vif
;21 = &5A vert citron
;22 = &59 vert pastel
;23 = &5B turquoise pastel
;24 = &4A jaune vif
;25 = &43 jaune pastel
;26 = &4B blanc