ORG &5B10
	;MODE 1
	LD A,1
	CALL &BC0E

	;border noir
	LD bc,0
	CALL &BC38

	;*** ECRAN PRS 21 ***
	CALL encrenoires
	CALL cacher_ecran
	LD HL,&7D0	;donnees
	LD DE,&C000	;destination
	CALL DECOMPECRAN
	CALL montrer_ecran
	CALL ecran21

	;*** ECRAN PRS 22 ***
	CALL encrenoires
	CALL cacher_ecran
	LD HL,&1D23	;donnees
	LD DE,&C000	;destination
	CALL DECOMPECRAN
	CALL montrer_ecran
	CALL ecran22

	;*** ECRAN PRS 23 ***
	CALL encrenoires
	CALL cacher_ecran
	LD HL,&2B96	;donnees
	LD DE,&C000	;destination
	CALL DECOMPECRAN
	CALL montrer_ecran
	CALL ecran23

	;*** ECRAN PRS 24 ***
	CALL encrenoires
	CALL cacher_ecran
	LD HL,&3D01	;donnees
	LD DE,&C000	;destination
	CALL DECOMPECRAN
	CALL montrer_ecran
	CALL ecran24

	;*** ECRAN PRS 25 ***
	CALL encrenoires
	CALL cacher_ecran
	LD HL,&4F65	;donnees
	LD DE,&C000	;destination
	CALL DECOMPECRAN
	CALL montrer_ecran
	CALL ecran25

	;FIN retour au basic
	CALL &BB6C	;CLS

	RET

.encrenoires
	CALL &BD19	; Ralentir pour eviter que ca saute a l'ecran
	LD BC,#7F00	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops
	LD BC,#7F02	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops
	LD BC,#7F03	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops
	ret


.Sauver
	DW #0000

.cacher_ecran
	LD BC,&BC06
	out (c),c
	LD BC,&BD00
	out (c),c
	RET	

.montrer_ecran
	LD BC,&BC06
	out (c),c
	LD BC,&BD00+25
	out (c),c
	RET


;----------------------------------------------------------------------------
;--- ECRAN 21 ---
;----------------
.ecran21
	XOR a
	LD bc,0
	CALL &BC32

	LD a,1
	LD bc,&0202
	CALL &BC32

	LD a,2
	LD bc,&1515
	CALL &BC32

	LD a,3
	LD bc,&1A1A
	CALL &BC32

	DI		; Desactiver les interruptions
	LD HL,(&38) 	; Lire l'ancienne interruption
	LD (Sauver),HL 	; Sauvegarder la valeur 16 bits
	LD HL,&C9FB 	; Registre 16 bits EI (&FB) + RET (&C9)
	LD (&38),HL 	; Ecrire en &0038 et &0039 le contenu du registre HL
	EI 		; Interruption autorisees

	;encre 0 - Noir
	LD BC,#7F00	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 1 - Bleu
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&55        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 2 - Vert citron
	LD BC,#7F02	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&5A        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 3 - Blanc
	LD BC,#7F03	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4B        ; 2 nops
	OUT (c),a       ; 4 nops

.loop21

	;encre 1
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops

	LD B,&F5 	; Se connecter au PPI/8255 port B accessible via &F5xx
.Balayage21
	IN A,(C) 	; Lire le contenu
	RRA 		; On teste si le bit 0 = 1
	JP nc,Balayage21; Si le bit 0 = 0 on boucle jusqu'a la fin du balayage
			; On est en haut de l'ecran, on peut continuer le programme

	HALT 		; Attendre interruption 1
	HALT 		; Attendre interruption 2

	DI		; 1 nop
	NOP

	; Position vertical (141 coin haut gauche)
	;+8 pour ligne graphique suivante
	;+64 pour ligne texte suivante
	LD BC,141
.WaitLoop21
	NOP		; 1 nop
	DEC BC		; 2 nops
	LD A,B		; 1 nop
	OR C		; 1 nops
	JR NZ,WaitLoop21; 3 nops, TOTAL 8 nops



	; split colors (6 couleurs = 12 nops)
	LD b,&55	; bleu vif par defaut (2 nops)
	LD c,&40	; gris (2 nops)
	LD h,&5B	; cyan (2 nops)
	LD l,&4C	; rouge
	LD d,&4F	; magenta pastel
	LD e,0


	; Position horizontal (40 colonne, 1 nop par colonne)
	DEFS 53,0

;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;SPLIT-RASTERS 1
;8 nops invisible
	LD a,43	;nombre de ligne graphique	(2 nops)
		splitrasterligne211:
		DEFS 6,0
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 9,0
		OUT (c),h  ; 4 nops
		DEFS 1,0
		OUT (c),l  ; 4 nops
		DEFS 22,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 6,0
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne211	;3 nops


;SPLIT-RASTERS 2
;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;8 nops invisible
	LD a,17	;nombre de ligne graphique	(2 nops)
		splitrasterligne212:
		DEFS 5,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 3,0
		OUT (c),c  ; 4 nops
		DEFS 2,0
		OUT (c),h
		NOP
		OUT (c),l
		DEFS 22,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 7,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne212	;3 nops


;SPLIT-RASTERS 3
;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;8 nops invisible
	LD a,36	;nombre de ligne graphique	(2 nops)
		splitrasterligne213:
		DEFS 4,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 3,0
		OUT (c),c  ; 4 nops
		DEFS 3,0
		OUT (c),b
		OUT (c),l
		DEFS 22,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 8,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne213	;3 nops


;SPLIT-RASTERS 4
;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;8 nops invisible
	LD a,11	;nombre de ligne graphique	(2 nops)
		splitrasterligne214:
		DEFS 3,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 3,0
		OUT (c),l  ; 4 nops
		DEFS 33,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 9,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne214	;3 nops


;SPLIT-RASTERS 5
;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;8 nops invisible
	LD a,60	;nombre de ligne graphique	(2 nops)
		splitrasterligne215:
		DEFS 2,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 3,0
		OUT (c),l  ; 4 nops
		DEFS 22,0
		OUT (c),b
		NOP
		OUT (c),l
		DEFS 2,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 10,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne215	;3 nops


;SPLIT-RASTERS 6
;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;8 nops invisible
	LD a,33	;nombre de ligne graphique	(2 nops)
		splitrasterligne216:
		DEFS 1,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 3,0
		OUT (c),l  ; 4 nops
		DEFS 7,0
		OUT (c),d
		DEFS 22,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 11,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne216	;3 nops

	OUT (c),b  ; couleur d'origine (4 nops)

	EI		; 1 nop



; Test touche
.Touche21
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F645	;ligne 5
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche ESPACE)
JR NC,Sortir21
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F649	;ligne 9
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche DEL)
	RLA		;Charge dans A la valeur du bit 6 (touche JOY_FIRE0)
	RLA		;Charge dans A la valeur du bit 5 (touche JOY_FIRE1 Z)
	RLA		;Charge dans A la valeur du bit 4 (touche JOY_FIRE2 X)
	JP C,loop21	;Si TIR du joystick n'a pas etait enfonce on boucle



.Sortir21
	;retour au BASIC
	DI 		; Desactiver les interruptions
	LD HL,(Sauver) 	; Restauration des anciennes interruptions
	LD (&38),hl 	; Ecrire
	EI 		; Interruption autorisees
	RET

;----------------------------------------------------------------------------
;--- ECRAN 2 ---
;---------------
.ecran22
	XOR a
	LD bc,0
	CALL &BC32

	LD a,1
	LD bc,&0202
	CALL &BC32

	LD a,2
	LD bc,&0606
	CALL &BC32

	LD a,3
	LD bc,&1A1A
	CALL &BC32

	DI		; Desactiver les interruptions
	LD HL,(&38) 	; Lire l'ancienne interruption
	LD (Sauver),HL 	; Sauvegarder la valeur 16 bits
	LD HL,&C9FB 	; Registre 16 bits EI (&FB) + RET (&C9)
	LD (&38),HL 	; Ecrire en &0038 et &0039 le contenu du registre HL
	EI 		; Interruption autorisees

	;encre 0 - Noir
	LD BC,#7F00	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 1 - Bleu
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&55        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 2 - Rouge
	LD BC,#7F02	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4C        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 3 - Blanc
	LD BC,#7F03	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4B        ; 2 nops
	OUT (c),a       ; 4 nops

.loop22

	;encre 1
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops

	LD B,&F5 	; Se connecter au PPI/8255 port B accessible via &F5xx
.Balayage22
	IN A,(C) 	; Lire le contenu
	RRA 		; On teste si le bit 0 = 1
	JP nc,Balayage22; Si le bit 0 = 0 on boucle jusqu'a la fin du balayage
			; On est en haut de l'ecran, on peut continuer le programme

	;HALT 		; Attendre interruption 1
	HALT 		; Attendre interruption 2

	DI		; 1 nop
	
	DEFS 41,0

	; Position vertical (68 coin haut gauche)
	;+1 pour ligne graphique suivante
	LD BC,68+29
.WaitLoop22
	DEFS 57,0
	DEC BC		; 2 nops
	LD A,B		; 1 nop
	OR C		; 1 nops
	JR NZ,WaitLoop22; 3 nops, TOTAL 8 nops



	; split colors (6 couleurs = 12 nops)
	LD b,&4C	; rouge vif par defaut (2 nops)
	LD c,&40	; gris (2 nops)
	LD h,&5B	; cyan (2 nops)
	LD l,&4A	; Jaune
	LD d,&4F	; magenta pastel
	LD e,0


	; Position horizontal (40 colonne, 1 nop par colonne)
	DEFS 53,0

;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;SPLIT-RASTERS 1
;8 nops invisible
	LD a,19	;nombre de ligne graphique	(2 nops)
		splitrasterligne221:
		DEFS 6,0
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 29,0
		OUT (c),h  ; 4 nops
		OUT (c),b  ; 4 nops
		DEFS 3,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 6,0
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne221	;3 nops


;SPLIT-RASTERS 2
;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;8 nops invisible
	LD a,13	;nombre de ligne graphique	(2 nops)
		splitrasterligne222:
		DEFS 5,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 8,0
		OUT (c),l  ; 4 nops
		DEFS 2,0
		OUT (c),b  ; 4 nops
		OUT (c),d
		OUT (c),h
		OUT (c),b  ; 4 nops
		DEFS 10,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 7,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne222	;3 nops


;SPLIT-RASTERS 3
;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;8 nops invisible
	LD a,8	;nombre de ligne graphique	(2 nops)
		splitrasterligne223:
		DEFS 4,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 8,0
		OUT (c),l  ; 4 nops
		DEFS 2,0
		OUT (c),b
		NOP
		OUT (c),d
		NOP
		OUT (c),c
		DEFS 6,0
		OUT (c),b
		DEFS 2,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 8,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne223	;3 nops


;SPLIT-RASTERS 4
;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;8 nops invisible
	LD a,25	;nombre de ligne graphique	(2 nops)
		splitrasterligne224:
		DEFS 3,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 5,0
		OUT (c),h  ; 4 nops
		OUT (c),b
		DEFS 3,0
		OUT (c),c
		DEFS 13,0
		OUT (c),b
		DEFS 3,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 9,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne224	;3 nops


;SPLIT-RASTERS 5
;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;8 nops invisible
	LD a,54	;nombre de ligne graphique	(2 nops)
		splitrasterligne225:
		DEFS 2,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 6,0
		OUT (c),l  ; 4 nops
		DEFS 4,0
		OUT (c),c
		DEFS 15,0
		OUT (c),b
		DEFS 3,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 10,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne225	;3 nops


;SPLIT-RASTERS 6
;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;8 nops invisible
	LD a,15	;nombre de ligne graphique	(2 nops)
		splitrasterligne226:
		DEFS 1,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 6,0
		OUT (c),l  ; 4 nops
		DEFS 4,0
		OUT (c),h
		DEFS 4,0
		OUT (c),b
		DEFS 14,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 11,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne226	;3 nops


;SPLIT-RASTERS 7
;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;8 nops invisible
	LD a,11	;nombre de ligne graphique	(2 nops)
		splitrasterligne227:
		;DEFS 1,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 6,0
		OUT (c),l  ; 4 nops
		DEFS 4,0
		OUT (c),h
		DEFS 3,0
		OUT (c),c
		DEFS 2,0
		OUT (c),b
		DEFS 9,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 12,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne227	;3 nops

;SPLIT-RASTERS 8 (uniquement pour aider au calage des Splits Raster - cochonerie de truc)
;8 nops invisible
	LD a,24	;nombre de ligne graphique	(2 nops)
		splitrasterligne228:
		;DEFS 1,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 40,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 12,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne228	;3 nops

	OUT (c),b  ; couleur d'origine (4 nops)

	EI		; 1 nop



; Test touche
.Touche22
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F645	;ligne 5
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche ESPACE)
JR NC,Sortir22
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F649	;ligne 9
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche DEL)
	RLA		;Charge dans A la valeur du bit 6 (touche JOY_FIRE0)
	RLA		;Charge dans A la valeur du bit 5 (touche JOY_FIRE1 Z)
	RLA		;Charge dans A la valeur du bit 4 (touche JOY_FIRE2 X)
	JP C,loop22	;Si TIR du joystick n'a pas etait enfonce on boucle



.Sortir22
	;retour au BASIC
	DI 		; Desactiver les interruptions
	LD HL,(Sauver) 	; Restauration des anciennes interruptions
	LD (&38),hl 	; Ecrire
	EI 		; Interruption autorisees
	RET

;----------------------------------------------------------------------------
;--- ECRAN 3 ---
;---------------
.ecran23
	XOR a
	LD bc,0
	CALL &BC32

	LD a,1
	LD bc,&0202
	CALL &BC32

	LD a,2
	LD bc,&0606
	CALL &BC32

	LD a,3
	LD bc,&1A1A
	CALL &BC32

	DI		; Desactiver les interruptions
	LD HL,(&38) 	; Lire l'ancienne interruption
	LD (Sauver),HL 	; Sauvegarder la valeur 16 bits
	LD HL,&C9FB 	; Registre 16 bits EI (&FB) + RET (&C9)
	LD (&38),HL 	; Ecrire en &0038 et &0039 le contenu du registre HL
	EI 		; Interruption autorisees

	;encre 0 - Noir
	LD BC,#7F00	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 1 - Bleu
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&55        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 2 - rouge vif
	LD BC,#7F02	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4C        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 3 - Blanc
	LD BC,#7F03	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4B        ; 2 nops
	OUT (c),a       ; 4 nops

.loop23

	;encre 1
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops

	LD B,&F5 	; Se connecter au PPI/8255 port B accessible via &F5xx
.Balayage23
	IN A,(C) 	; Lire le contenu
	RRA 		; On teste si le bit 0 = 1
	JP nc,Balayage23; Si le bit 0 = 0 on boucle jusqu'a la fin du balayage
			; On est en haut de l'ecran, on peut continuer le programme

	;HALT 		; Attendre interruption 1
	HALT 		; Attendre interruption 2

	DI		; 1 nop
	NOP
	NOP

	; Position vertical (141 coin haut gauche)
	;+8 pour ligne graphique suivante
	;+64 pour ligne texte suivante
	LD BC,141+64+64+64
.WaitLoop23
	NOP		; 1 nop
	DEC BC		; 2 nops
	LD A,B		; 1 nop
	OR C		; 1 nops
	JR NZ,WaitLoop23; 3 nops, TOTAL 8 nops



	; split colors (6 couleurs = 12 nops)
	LD b,&55	; bleu vif par defaut (2 nops)
	LD c,&40	; gris (2 nops)
	LD h,&4F	; magenta pastel
	LD l,&4A	; Jaune
	LD d,&5D	; Mauve
	LD e,&53	; Cyan


	; Position horizontal (40 colonne, 1 nop par colonne)
	DEFS 53,0

;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;SPLIT-RASTERS 1
;8 nops invisible
	LD a,76+29	;nombre de ligne graphique	(2 nops)
		splitrasterligne231:
		DEFS 6,0
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 2,0
		OUT (c),h  ; 4 nops
		DEFS 11,0
		OUT (c),b  ; 4 nops
		DEFS 19,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 6,0
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne231	;3 nops


;SPLIT-RASTERS 2
;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;8 nops invisible
	LD a,22	;nombre de ligne graphique	(2 nops)
		splitrasterligne232:
		DEFS 5,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 30,0
		OUT (c),l  ; 4 nops
		NOP
		OUT (c),b  ; 4 nops
		NOP
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 7,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne232	;3 nops


;SPLIT-RASTERS 3
;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;8 nops invisible
	LD a,16	;nombre de ligne graphique	(2 nops)
		splitrasterligne233:
		DEFS 4,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 18,0
		OUT (c),c  ; 4 nops
		DEFS 8,0
		OUT (c),d  ; 4 nops
		NOP
		OUT (c),b  ; 4 nops
		NOP
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 8,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne233	;3 nops


;SPLIT-RASTERS 4
;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;8 nops invisible
	LD a,44	;nombre de ligne graphique	(2 nops)
		splitrasterligne234:
		DEFS 3,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 18,0
		OUT (c),c  ; 4 nops
		DEFS 3,0
		OUT (c),l  ; 4 nops
		DEFS 2,0 
		OUT (c),b  ; 4 nops
		DEFS 5,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 9,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne234	;3 nops


;SPLIT-RASTERS 5
;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;8 nops invisible
	LD a,36	;nombre de ligne graphique	(2 nops)
		splitrasterligne235:
		DEFS 2,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 2,0
		OUT (c),l  ; 4 nops
		DEFS 2,0
		OUT (c),e  ; 4 nops
		OUT (c),l  ; 4 nops
		DEFS 5,0
		OUT (c),b  ; 4 nops
		DEFS 15,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 10,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne235	;3 nops


	;OUT (c),b  ; couleur d'origine (4 nops)

	EI		; 1 nop



; Test touche
.Touche23
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F645	;ligne 5
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche ESPACE)
JR NC,Sortir23
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F649	;ligne 9
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche DEL)
	RLA		;Charge dans A la valeur du bit 6 (touche JOY_FIRE0)
	RLA		;Charge dans A la valeur du bit 5 (touche JOY_FIRE1 Z)
	RLA		;Charge dans A la valeur du bit 4 (touche JOY_FIRE2 X)
	JP C,loop23	;Si TIR du joystick n'a pas etait enfonce on boucle



.Sortir23
	;retour au BASIC
	DI 		; Desactiver les interruptions
	LD HL,(Sauver) 	; Restauration des anciennes interruptions
	LD (&38),hl 	; Ecrire
	EI 		; Interruption autorisees
	RET

;----------------------------------------------------------------------------
;--- ECRAN 4 ---
;---------------
.ecran24
	XOR a
	LD bc,0
	CALL &BC32

	LD a,1
	LD bc,&0202
	CALL &BC32

	LD a,2
	LD bc,&0606
	CALL &BC32

	LD a,3
	LD bc,&1A1A
	CALL &BC32

	DI		; Desactiver les interruptions
	LD HL,(&38) 	; Lire l'ancienne interruption
	LD (Sauver),HL 	; Sauvegarder la valeur 16 bits
	LD HL,&C9FB 	; Registre 16 bits EI (&FB) + RET (&C9)
	LD (&38),HL 	; Ecrire en &0038 et &0039 le contenu du registre HL
	EI 		; Interruption autorisees

	;encre 0 - Noir
	LD BC,#7F00	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 1 - Bleu
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&55        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 2 - rouge vif
	LD BC,#7F02	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4C        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 3 - Blanc
	LD BC,#7F03	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4B        ; 2 nops
	OUT (c),a       ; 4 nops

.loop24

	;encre 1
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops

	LD B,&F5 	; Se connecter au PPI/8255 port B accessible via &F5xx
.Balayage24
	IN A,(C) 	; Lire le contenu
	RRA 		; On teste si le bit 0 = 1
	JP nc,Balayage24; Si le bit 0 = 0 on boucle jusqu'a la fin du balayage
			; On est en haut de l'ecran, on peut continuer le programme

	HALT 		; Attendre interruption 1
	;HALT 		; Attendre interruption 2

	DI		; 1 nop
	NOP

	; Position vertical (141 coin haut gauche)
	;+8 pour ligne graphique suivante
	;+64 pour ligne texte suivante
	LD BC,141+64+64+64+64+64+64+8+8+8+64+64+64
.WaitLoop24
	NOP		; 1 nop
	DEC BC		; 2 nops
	LD A,B		; 1 nop
	OR C		; 1 nops
	JR NZ,WaitLoop24; 3 nops, TOTAL 8 nops



	; split colors (6 couleurs = 12 nops)
	LD b,&55	; bleu vif par defaut (2 nops)
	LD c,&53	; turquoise vif (2 nops)
	LD h,&40	; gris (2 nops)
	LD l,0
	LD d,0
	LD e,0


	; Position horizontal (40 colonne, 1 nop par colonne)
	DEFS 53,0

;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;SPLIT-RASTERS 1
;8 nops invisible
	LD a,22	;nombre de ligne graphique	(2 nops)
		splitrasterligne241:
		DEFS 6,0
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 26,0
		OUT (c),c  ; 4 nops
		DEFS 6,0
		OUT (c),b  ; 4 nops
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 6,0
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne241	;3 nops


;SPLIT-RASTERS 2
;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;8 nops invisible
	LD a,98	;nombre de ligne graphique	(2 nops)
		splitrasterligne242:
		DEFS 5,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 17,0
		OUT (c),h  ; 4 nops
		DEFS 15,0
		OUT (c),b  ; 4 nops
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 7,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne242	;3 nops


	OUT (c),b  ; couleur d'origine (4 nops)

	EI		; 1 nop



; Test touche
.Touche24
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F645	;ligne 5
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche ESPACE)
JR NC,Sortir24
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F649	;ligne 9
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche DEL)
	RLA		;Charge dans A la valeur du bit 6 (touche JOY_FIRE0)
	RLA		;Charge dans A la valeur du bit 5 (touche JOY_FIRE1 Z)
	RLA		;Charge dans A la valeur du bit 4 (touche JOY_FIRE2 X)
	JP C,loop24	;Si TIR du joystick n'a pas etait enfonce on boucle



.Sortir24
	;retour au BASIC
	DI 		; Desactiver les interruptions
	LD HL,(Sauver) 	; Restauration des anciennes interruptions
	LD (&38),hl 	; Ecrire
	EI 		; Interruption autorisees
	RET

;----------------------------------------------------------------------------
;--- ECRAN 5 ---
;---------------
.ecran25
	XOR a
	LD bc,0
	CALL &BC32

	LD a,1
	LD bc,&0606
	CALL &BC32

	LD a,2
	LD bc,&1414
	CALL &BC32

	LD a,3
	LD bc,&1A1A
	CALL &BC32

	DI		; Desactiver les interruptions
	LD HL,(&38) 	; Lire l'ancienne interruption
	LD (Sauver),HL 	; Sauvegarder la valeur 16 bits
	LD HL,&C9FB 	; Registre 16 bits EI (&FB) + RET (&C9)
	LD (&38),HL 	; Ecrire en &0038 et &0039 le contenu du registre HL
	EI 		; Interruption autorisees

	;encre 0 - Noir
	LD BC,#7F00	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 1 - rouge vif
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4C        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 2 - turquoise vif
	LD BC,#7F02	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&53        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 3 - Blanc
	LD BC,#7F03	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4B        ; 2 nops
	OUT (c),a       ; 4 nops

.loop25

	LD B,&F5 	; Se connecter au PPI/8255 port B accessible via &F5xx
.Balayage25
	IN A,(C) 	; Lire le contenu
	RRA 		; On teste si le bit 0 = 1
	JP nc,Balayage25; Si le bit 0 = 0 on boucle jusqu'a la fin du balayage
			; On est en haut de l'ecran, on peut continuer le programme


	HALT 		; Attendre interruption 1
	HALT 		; Attendre interruption 2

	;positionnement
	LD a,169
.decalage25
	DEFS 12,0		;4 nop
	DEC a			;1 nop
	JP nz,decalage25	;3 nops

	;ajustement
	DEFS 1

	;encre 1
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops

	LD hl,table_rasters ; 3 nops
	LD e,total_raster   ; (nb de rasters a lire) 2 nops

.lire_couleur_raster
	LD a,(hl)                 ; 2 nops
	INC hl                    ; 2 nops
	OUT (c),a                 ; 4 nops

	;synchronisation (64 nops par ligne)
	defs 64-4-2-2-1-3

	DEC e                     ; 1 nops
	JP nz,lire_couleur_raster ; 3 nops

; Test touche
.Touche25
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F645	;ligne 5
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche ESPACE)
JR NC,Sortir25
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F649	;ligne 9
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche DEL)
	RLA		;Charge dans A la valeur du bit 6 (touche JOY_FIRE0)
	RLA		;Charge dans A la valeur du bit 5 (touche JOY_FIRE1 Z)
	RLA		;Charge dans A la valeur du bit 4 (touche JOY_FIRE2 X)
	JP C,loop25	;Si TIR du joystick n'a pas etait enfonce on boucle

.Sortir25
	;retour au BASIC
	DI 		; Desactiver les interruptions
	LD HL,(Sauver) 	; Restauration des anciennes interruptions
	LD (&38),hl 	; Ecrire
	EI 		; Interruption autorisees
	RET


total_raster EQU 1+12+18+47+40+14+22+1

.table_rasters
;noir (1)
DEFB &54
;rouge (12)
DEFB &4C,&4C,&4C,&4C,&4C,&4C,&4C,&4C,&4C,&4C,&4C,&4C
;violet (18)
DEFB &4D,&4D,&4D,&4D,&4D,&4D,&4D,&4D,&4D,&4D,&4D,&4D
DEFB &4D,&4D,&4D,&4D,&4D,&4D
;jaune (47)
DEFB &4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A
DEFB &4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A
DEFB &4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A
DEFB &4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A
DEFB &4A,&4A,&4A,&4A,&4A,&4A,&4A
;gris (40)
DEFB &40,&40,&40,&40,&40,&40,&40,&40,&40,&40
DEFB &40,&40,&40,&40,&40,&40,&40,&40,&40,&40
DEFB &40,&40,&40,&40,&40,&40,&40,&40,&40,&40
DEFB &40,&40,&40,&40,&40,&40,&40,&40,&40,&40
;vert vif (14)
DEFB &52,&52,&52,&52,&52,&52,&52,&52,&52,&52
DEFB &52,&52,&52,&52
;bleu (22)
DEFB &55,&55,&55,&55,&55,&55,&55,&55,&55,&55
DEFB &55,&55,&55,&55,&55,&55,&55,&55,&55,&55
DEFB &55,&55
;noir (1)
DEFB &54


;00 = &54 noir
;01 = &44 bleu
;02 = &55 bleu vif
;03 = &5C rouge fonce
;04 = &58 magenta
;05 = &5D mauve
;06 = &4C rouge vif
;07 = &45 pourpre
;08 = &4D magenta vif
;09 = &56 vert
;10 = &46 turquoise
;11 = &57 bleu ciel
;12 = &5E jaune
;13 = &40 gris
;14 = &5F bleu pastel
;15 = &4E orange
;16 = &47 rose
;17 = &4F magenta pastel
;18 = &52 vert vif
;19 = &42 vert marin
;20 = &53 turquoise vif
;21 = &5A vert citron
;22 = &59 vert pastel
;23 = &5B turquoise pastel
;24 = &4A jaune vif
;25 = &43 jaune pastel
;26 = &4B blanc

;------------------------------------------------------------------------------
;list
; Aplib decrunching routine
;nolist
; (c) CNGSOFT
; En entree, on a :
; HL = implantation du code compacte
; DE = implantation du code decompacte
;------------------------------------------------------------------------------
DECOMPECRAN
	;DI
        ;LD HL,CHOIXECRAN
        ;LD DE,&C000

        CALL boot
        JP &000F

; Maxam source by T&J/GPA -  01/18/2008
; Nothing changed, except thy damned hidden opcodes
; and a new variable for Maxam ( 13+8*0 = 0 for Maxam )
; Attention, cette routine contient un assemblage conditionnel.
; Si Aplib8flag = 0, le code decompacte est ecrite du bas de la
; memoire vers le haut de la memoire. C est ce que font par defaut
; les programmes modifies par Dadman/CEZ - Team (APPACK.EXE et
; aPPackWin.exe.

; Si Aplib8flag = 1, le code decompacte est ecrit du haut de la
; memoire vers le bas de la memoire. Le code compacte doit bien
; evidemment etre organise en consequence.
aplib8flag equ &0  ; = DEC  &00 pour INC

flagdecde equ aplib8flag*8 ; for Maxam compatibility

Boot
 PUSH HL ; used for EX HL,(SP)
 PUSH HL
  POP IX
 DB &FD,&26,&80 ; LD IYh,&80
  
aplib8literal

 LD A,(IX+ &00)

 DB &DD,&23 + flagdecde ; INC IX/DEC IX
 
 LD (DE),A
 
 DB &13 + flagdecde ; INC DE/DEC DE
 DB &FD,&2E,&02       ; LD IYl,&2

aplib8nexttag

 CALL aplib8getbit
  JR NC, aplib8literal
 LD BC,&0000
 CALL aplib8getbit
 JR NC, aplib8codepair
 LD H,B
 CALL aplib8getbit
 JR NC, aplib8shortmatch
 DB &FD,&2E,&02      ; LD IYl,2
 INC C ; bc
 LD L,&10

aplib8getmorebits

 CALL aplib8getbit
 RL L
 JR NC, aplib8getmorebits
 JR NZ, aplib8domatch
  LD A,L
 LD (DE),A
 DB &13+ flagdecde ; INC DE/DEC DE
 JR aplib8nexttag

aplib8codepair
 
 CALL aplib8getgamma
  DB &FD,&4D  ; LD C,IYl
 SBC HL,BC
  JR NZ, aplib8normalcodepair
 CALL aplib8getgamma
  LD B,H
 JR aplib8domatch_lastpos

aplib8normalcodepair

 DEC L
 LD H,L
  LD L,(IX + &00)
 DB &DD,&23+ flagdecde ; INC IX/DEC IX
  PUSH HL
 CALL aplib8getgamma
 LD B,H
  POP HL
 LD A,H
 CP 125 ; cmp eax,32000
  JR NC, aplib8domatch_with_2inc
 CP &05
  JR NC, aplib8domatch_with_inc
 AND A
  JR NZ, aplib8domatch_new_lastpos
 LD A,L
  ADD A
 JR C, aplib8domatch_new_lastpos

aplib8domatch_with_2inc 

 INC BC
 
aplib8domatch_with_inc

 INC BC
aplib8domatch_new_lastpos

 EX (SP),HL
 
aplib8domatch_lastpos

 POP HL
 PUSH HL
  DB &FD,&2E,&01  ; LD IYl,1

aplib8domatch

if aplib8flag ; LDIR/LDDR

  ADD HL,DE
   LDDR
else
 AND A
  EX DE,HL
   SBC HL,DE
   EX DE,HL
   ADD HL,DE
 EX DE,HL
  LDIR
endif
 JR aplib8nexttag

aplib8shortmatch

 LD L,(IX+&00)
 DB &DD,&23+ flagdecde ; INC IX/DEC IX
  SRL L
 JR Z, aplib8donedepacking
  RL C
 JR aplib8domatch_with_2inc

aplib8getbit

 DB &FD,&7C ; LD A,IYh
 ADD A
  JR NZ,aplib8getbit_
  LD A,(IX + &00)
 DB &DD,&23+ flagdecde ; INC IX/DEC IX
  ADC A

aplib8getbit_

 DB &FD,&67 ; LD  IYh,A
 RET

aplib8getgamma

 LD HL,&0001
 
aplib8getgamma_ 
 CALL aplib8getbit
 ADC HL,HL
  CALL aplib8getbit
 JR C, aplib8getgamma_
  LD C,L
 RET

aplib8donedepacking

 POP HL ; used for EX HL,(SP)
 PUSH IX
  POP HL
 RET ; Warning, A might not be 0!