ORG &8000
WRITE DIRECT "ECRAN25.BIN"

	LD bc,0
	CALL &BC38

;ECRAN 25
	XOR a
	LD bc,0
	CALL &BC32

	LD a,1
	LD bc,&0606
	CALL &BC32

	LD a,2
	LD bc,&1414
	CALL &BC32

	LD a,3
	LD bc,&1A1A
	CALL &BC32

	DI		; Desactiver les interruptions
	LD HL,(&38) 	; Lire l'ancienne interruption
	LD (Sauver),HL 	; Sauvegarder la valeur 16 bits
	LD HL,&C9FB 	; Registre 16 bits EI (&FB) + RET (&C9)
	LD (&38),HL 	; Ecrire en &0038 et &0039 le contenu du registre HL
	EI 		; Interruption autorisees

.loop25

	LD B,&F5 	; Se connecter au PPI/8255 port B accessible via &F5xx
.Balayage25
	IN A,(C) 	; Lire le contenu
	RRA 		; On teste si le bit 0 = 1
	JP nc,Balayage25; Si le bit 0 = 0 on boucle jusqu'a la fin du balayage
			; On est en haut de l'ecran, on peut continuer le programme


	HALT 		; Attendre interruption 1
	HALT 		; Attendre interruption 2

	;positionnement
	LD a,169
.decalage25
	DEFS 12,0		;4 nop
	DEC a			;1 nop
	JP nz,decalage25	;3 nops

	;ajustement
	DEFS 1

	;encre 1
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops

	LD hl,table_rasters ; 3 nops
	LD e,total_raster   ; (nb de rasters a lire) 2 nops

.lire_couleur_raster
	LD a,(hl)                 ; 2 nops
	INC hl                    ; 2 nops
	OUT (c),a                 ; 4 nops

	;synchronisation (64 nops par ligne)
	defs 64-4-2-2-1-3

	DEC e                     ; 1 nops
	JP nz,lire_couleur_raster ; 3 nops

; Test touche
.Touche25
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F645	;ligne 5
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche ESPACE)
JR NC,Sortir25
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F649	;ligne 9
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche DEL)
	RLA		;Charge dans A la valeur du bit 6 (touche JOY_FIRE0)
	RLA		;Charge dans A la valeur du bit 5 (touche JOY_FIRE1 Z)
	RLA		;Charge dans A la valeur du bit 4 (touche JOY_FIRE2 X)
	JP C,loop25	;Si TIR du joystick n'a pas etait enfonce on boucle

.Sortir25
	;retour au BASIC
	DI 		; Desactiver les interruptions
	LD HL,(Sauver) 	; Restauration des anciennes interruptions
	LD (&38),hl 	; Ecrire
	EI 		; Interruption autorisees
	RET

.Sauver
	DW #0000


total_raster EQU 1+12+18+47+40+14+22+1

.table_rasters
;noir (1)
DEFB &54
;rouge (12)
DEFB &4C,&4C,&4C,&4C,&4C,&4C,&4C,&4C,&4C,&4C,&4C,&4C
;violet (18)
DEFB &4D,&4D,&4D,&4D,&4D,&4D,&4D,&4D,&4D,&4D,&4D,&4D
DEFB &4D,&4D,&4D,&4D,&4D,&4D
;jaune (47)
DEFB &4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A
DEFB &4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A
DEFB &4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A
DEFB &4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A
DEFB &4A,&4A,&4A,&4A,&4A,&4A,&4A
;gris (40)
DEFB &40,&40,&40,&40,&40,&40,&40,&40,&40,&40
DEFB &40,&40,&40,&40,&40,&40,&40,&40,&40,&40
DEFB &40,&40,&40,&40,&40,&40,&40,&40,&40,&40
DEFB &40,&40,&40,&40,&40,&40,&40,&40,&40,&40
;vert vif (14)
DEFB &52,&52,&52,&52,&52,&52,&52,&52,&52,&52
DEFB &52,&52,&52,&52
;bleu (22)
DEFB &55,&55,&55,&55,&55,&55,&55,&55,&55,&55
DEFB &55,&55,&55,&55,&55,&55,&55,&55,&55,&55
DEFB &55,&55
;noir (1)
DEFB &54


;00 = &54 noir
;01 = &44 bleu
;02 = &55 bleu vif
;03 = &5C rouge fonce
;04 = &58 magenta
;05 = &5D mauve
;06 = &4C rouge vif
;07 = &45 pourpre
;08 = &4D magenta vif
;09 = &56 vert
;10 = &46 turquoise
;11 = &57 bleu ciel
;12 = &5E jaune
;13 = &40 gris
;14 = &5F bleu pastel
;15 = &4E orange
;16 = &47 rose
;17 = &4F magenta pastel
;18 = &52 vert vif
;19 = &42 vert marin
;20 = &53 turquoise vif
;21 = &5A vert citron
;22 = &59 vert pastel
;23 = &5B turquoise pastel
;24 = &4A jaune vif
;25 = &43 jaune pastel
;26 = &4B blanc