ORG &5F88
	;MODE 1
	LD A,1
	CALL &BC0E

	;border noir
	LD bc,0
	CALL &BC38

	;*** ECRAN PRS 31 ***
	CALL encrenoires
	CALL cacher_ecran
	LD HL,&7D0	;donnees
	LD DE,&C000	;destination
	CALL DECOMPECRAN
	CALL montrer_ecran
	CALL ecran31

	;*** ECRAN PRS 32 ***
	CALL encrenoires
	CALL cacher_ecran
	LD HL,&1D0B	;donnees
	LD DE,&C000	;destination
	CALL DECOMPECRAN
	CALL montrer_ecran
	CALL ecran32

	;*** ECRAN PRS 33 ***
	CALL encrenoires
	CALL cacher_ecran
	LD HL,&2AB3	;donnees
	LD DE,&C000	;destination
	CALL DECOMPECRAN
	CALL montrer_ecran
	CALL ecran33

	;*** ECRAN PRS 34 ***
	CALL encrenoires
	CALL cacher_ecran
	LD HL,&40A8	;donnees
	LD DE,&C000	;destination
	CALL DECOMPECRAN
	CALL montrer_ecran
	CALL ecran34

	;*** ECRAN PRS 35 ***
	CALL encrenoires
	CALL cacher_ecran
	LD HL,&53E1	;donnees
	LD DE,&C000	;destination
	CALL DECOMPECRAN
	CALL montrer_ecran
	CALL ecran35

	;FIN retour au basic
	CALL &BB6C	;CLS

	RET

.encrenoires
	CALL &BD19	; Ralentir pour eviter que ca saute a l'ecran
	LD BC,#7F00	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops
	LD BC,#7F02	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops
	LD BC,#7F03	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops
	ret


.Sauver
	DW #0000

.cacher_ecran
	LD BC,&BC06
	out (c),c
	LD BC,&BD00
	out (c),c
	RET	

.montrer_ecran
	LD BC,&BC06
	out (c),c
	LD BC,&BD00+25
	out (c),c
	RET


;----------------------------------------------------------------------------
;--- ECRAN 31 ---
;---------------
.ecran31
	XOR a
	LD bc,0
	CALL &BC32

	LD a,1
	LD bc,&0202
	CALL &BC32

	LD a,2
	LD bc,&0606
	CALL &BC32

	LD a,3
	LD bc,&1A1A
	CALL &BC32

	DI		; Desactiver les interruptions
	LD HL,(&38) 	; Lire l'ancienne interruption
	LD (Sauver),HL 	; Sauvegarder la valeur 16 bits
	LD HL,&C9FB 	; Registre 16 bits EI (&FB) + RET (&C9)
	LD (&38),HL 	; Ecrire en &0038 et &0039 le contenu du registre HL
	EI 		; Interruption autorisees

	;encre 0 - Noir
	LD BC,#7F00	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 1 - Bleu
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&55        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 2 - rouge vif
	LD BC,#7F02	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4C        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 3 - Blanc
	LD BC,#7F03	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4B        ; 2 nops
	OUT (c),a       ; 4 nops

.loop31

	;encre 2
	LD BC,#7F02	; 3 nops
	OUT (c),c	; 4 nops

	LD B,&F5 	; Se connecter au PPI/8255 port B accessible via &F5xx
.Balayage31
	IN A,(C) 	; Lire le contenu
	RRA 		; On teste si le bit 0 = 1
	JP nc,Balayage31; Si le bit 0 = 0 on boucle jusqu'a la fin du balayage
			; On est en haut de l'ecran, on peut continuer le programme

	HALT 		; Attendre interruption 1
	HALT 		; Attendre interruption 2

	DI		; 1 nop
	NOP

	; Position vertical (141 coin haut gauche)
	;+8 pour ligne graphique suivante
	;+64 pour ligne texte suivante
	LD BC,141
.WaitLoop31
	NOP		; 1 nop
	DEC BC		; 2 nops
	LD A,B		; 1 nop
	OR C		; 1 nops
	JR NZ,WaitLoop31; 3 nops, TOTAL 8 nops



	; split colors (6 couleurs = 12 nops)
	LD b,&4C	; rouge vif par defaut pour la premiere partie de l'image (2 nops)
	LD c,&4A	; jaune vif (2 nops)
	LD h,&53	; turquoise vif (2 nops)
	LD l,&40	; gris (2 nops)
	LD d,&4D	; magenta vif (2 nops)
	LD e,&55	; bleu par defaut pour la deuxieme partie de l'image (2 nops)


	; Position horizontal (40 colonne, 1 nop par colonne)
	DEFS 53,0

;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;SPLIT-RASTERS 1
;8 nops invisible
	LD a,32	;nombre de ligne graphique	(2 nops)
		splitrasterligne311:
		DEFS 6,0
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 14,0
		OUT (c),h  ; 4 nops
		DEFS 19,0
		OUT (c),b  ; 4 nops
;4 nops border droit
		DEFS 3,0
;8 nops invisible
		DEFS 6,0
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne311	;3 nops

;ligne changement de couleur + reequilibrage	
	;encre 1
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops

	LD b,&4C	; rouge vif par defaut pour la premiere partie de l'image (2 nops)
	LD c,&4A	; jaune vif (2 nops)

	DEFS 52,0

;SPLIT-RASTERS 2
;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;8 nops invisible
	LD a,22	;nombre de ligne graphique	(2 nops)
		splitrasterligne312:
		DEFS 6,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),e  ; 4 nops
;40 nops - ecran normal
		DEFS 40,0
;4 nops border droit
		OUT (c),e  ; 4 nops
;8 nops invisible
		DEFS 6,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne312	;3 nops

;SPLIT-RASTERS 3
;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;8 nops invisible
	LD a,23	;nombre de ligne graphique	(2 nops)
		splitrasterligne313:
		DEFS 5,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),e  ; 4 nops
;40 nops - ecran normal
		DEFS 19,0
		OUT (c),l	;4 nops
		DEFS 10,0
		OUT (c),e  ; 4 nops
		DEFS 3,0
;4 nops border droit
		OUT (c),e  ; 4 nops
;8 nops invisible
		DEFS 7,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne313	;3 nops
	
	
;SPLIT-RASTERS 4
;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;8 nops invisible
	LD a,57	;nombre de ligne graphique	(2 nops)
		splitrasterligne314:
		DEFS 4,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),e  ; 4 nops
;40 nops - ecran normal
		DEFS 3,0
		OUT (c),d	;4 nops
		DEFS 18,0
		OUT (c),c  ; 4 nops
		NOP
		OUT (c),e	;4 nops
		DEFS 6,0
;4 nops border droit
		OUT (c),e  ; 4 nops
;8 nops invisible
		DEFS 8,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne314	;3 nops
	
	
;SPLIT-RASTERS 5
;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;8 nops invisible
	LD a,63	;nombre de ligne graphique	(2 nops)
		splitrasterligne315:
		DEFS 3,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),e  ; 4 nops
;40 nops - ecran normal
		DEFS 3,0
		OUT (c),d	;4 nops
		DEFS 23,0
		OUT (c),e	;4 nops
		DEFS 6,0
;4 nops border droit
		OUT (c),e  ; 4 nops
;8 nops invisible
		DEFS 9,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne315	;3 nops


	;couleurs d'origine (sinon soucis lors du loop)

	;encre 1 - Bleu
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&55        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 2 - rouge vif
	LD BC,#7F02	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4C        ; 2 nops
	OUT (c),a       ; 4 nops


	EI		; 1 nop



; Test touche
.Touche31
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F645	;ligne 5
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche ESPACE)
JR NC,Sortir31
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F649	;ligne 9
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche DEL)
	RLA		;Charge dans A la valeur du bit 6 (touche JOY_FIRE0)
	RLA		;Charge dans A la valeur du bit 5 (touche JOY_FIRE1 Z)
	RLA		;Charge dans A la valeur du bit 4 (touche JOY_FIRE2 X)
	JP C,loop31	;Si TIR du joystick n'a pas etait enfonce on boucle



.Sortir31
	;retour au BASIC
	DI 		; Desactiver les interruptions
	LD HL,(Sauver) 	; Restauration des anciennes interruptions
	LD (&38),hl 	; Ecrire
	EI 		; Interruption autorisees
	RET

;----------------------------------------------------------------------------
;--- ECRAN 32 ---
;---------------
.ecran32
	XOR a
	LD bc,0
	CALL &BC32

	LD a,1
	LD bc,&0202
	CALL &BC32

	LD a,2
	LD bc,&0606
	CALL &BC32

	LD a,3
	LD bc,&1A1A
	CALL &BC32

	DI		; Desactiver les interruptions
	LD HL,(&38) 	; Lire l'ancienne interruption
	LD (Sauver),HL 	; Sauvegarder la valeur 16 bits
	LD HL,&C9FB 	; Registre 16 bits EI (&FB) + RET (&C9)
	LD (&38),HL 	; Ecrire en &0038 et &0039 le contenu du registre HL
	EI 		; Interruption autorisees

	;encre 0 - Noir
	LD BC,#7F00	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 1 - Bleu
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&55        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 2 - rouge vif
	LD BC,#7F02	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4C        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 3 - Blanc
	LD BC,#7F03	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4B        ; 2 nops
	OUT (c),a       ; 4 nops

.loop32

	;encre 1
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops

	LD B,&F5 	; Se connecter au PPI/8255 port B accessible via &F5xx
.Balayage32
	IN A,(C) 	; Lire le contenu
	RRA 		; On teste si le bit 0 = 1
	JP nc,Balayage32; Si le bit 0 = 0 on boucle jusqu'a la fin du balayage
			; On est en haut de l'ecran, on peut continuer le programme

	HALT 		; Attendre interruption 1
	HALT 		; Attendre interruption 2

	DI		; 1 nop
	NOP

	; Position vertical (141 coin haut gauche)
	;+8 pour ligne graphique suivante
	;+64 pour ligne texte suivante
	LD BC,141-8
.WaitLoop32
	NOP		; 1 nop
	DEC BC		; 2 nops
	LD A,B		; 1 nop
	OR C		; 1 nops
	JR NZ,WaitLoop32; 3 nops, TOTAL 8 nops



	; split colors (6 couleurs = 12 nops)
	LD b,&55	; bleu par defaut (2 nops)
	LD c,0		; (2 nops)
	LD h,&53	; turquoise vif (2 nops)
	LD l,&58	; magenta (2 nops)
	LD d,&4D	; magenta vif (2 nops)
	LD e,0		; (2 nops)


	; Position horizontal (40 colonne, 1 nop par colonne)
	DEFS 53,0

;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;SPLIT-RASTERS 1
;8 nops invisible
	LD a,109	;nombre de ligne graphique	(2 nops)
		splitrasterligne321:
		DEFS 6,0
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 10,0
		OUT (c),h  ; 4 nops
		NOP
		OUT (c),b  ; 4 nops
		NOP
		OUT (c),h  ; 4 nops
		NOP
		OUT (c),b  ; 4 nops
		DEFS 11,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 6,0
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne321	;3 nops

	
;SPLIT-RASTERS 2
;8 nops invisible
	LD a,16	;nombre de ligne graphique	(2 nops)
		splitrasterligne322:
		DEFS 5,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 3,0
		OUT (c),d  ; 4 nops
		DEFS 18,0
		OUT (c),b  ; 4 nops
		DEFS 11,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 7,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne322	;3 nops

	
;SPLIT-RASTERS 3
;8 nops invisible
	LD a,24	;nombre de ligne graphique	(2 nops)
		splitrasterligne323:
		DEFS 4,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 40,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 8,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne323	;3 nops

	
;SPLIT-RASTERS 4
;8 nops invisible
	LD a,16	;nombre de ligne graphique	(2 nops)
		splitrasterligne324:
		DEFS 3,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 3,0
		OUT (c),l  ; 4 nops
		DEFS 13,0
		OUT (c),b  ; 4 nops
		DEFS 16,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 9,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne324	;3 nops	
	

	;couleurs d'origine
	OUT (c),b  ; 4 nops


	EI		; 1 nop



; Test touche
.Touche32
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F645	;ligne 5
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche ESPACE)
JR NC,Sortir32
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F649	;ligne 9
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche DEL)
	RLA		;Charge dans A la valeur du bit 6 (touche JOY_FIRE0)
	RLA		;Charge dans A la valeur du bit 5 (touche JOY_FIRE1 Z)
	RLA		;Charge dans A la valeur du bit 4 (touche JOY_FIRE2 X)
	JP C,loop32	;Si TIR du joystick n'a pas etait enfonce on boucle



.Sortir32
	;retour au BASIC
	DI 		; Desactiver les interruptions
	LD HL,(Sauver) 	; Restauration des anciennes interruptions
	LD (&38),hl 	; Ecrire
	EI 		; Interruption autorisees
	RET

;----------------------------------------------------------------------------
;--- ECRAN 33 ---
;---------------
.ecran33
	XOR a
	LD bc,0
	CALL &BC32

	LD a,1
	LD bc,&0202
	CALL &BC32

	LD a,2
	LD bc,&0606
	CALL &BC32

	LD a,3
	LD bc,&1A1A
	CALL &BC32

	DI		; Desactiver les interruptions
	LD HL,(&38) 	; Lire l'ancienne interruption
	LD (Sauver),HL 	; Sauvegarder la valeur 16 bits
	LD HL,&C9FB 	; Registre 16 bits EI (&FB) + RET (&C9)
	LD (&38),HL 	; Ecrire en &0038 et &0039 le contenu du registre HL
	EI 		; Interruption autorisees

	;encre 0 - Noir
	LD BC,#7F00	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 1 - Bleu
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&55        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 2 - rouge vif
	LD BC,#7F02	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4C        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 3 - Blanc
	LD BC,#7F03	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4B        ; 2 nops
	OUT (c),a       ; 4 nops

.loop33

	;encre 1
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops

	LD B,&F5 	; Se connecter au PPI/8255 port B accessible via &F5xx
.Balayage33
	IN A,(C) 	; Lire le contenu
	RRA 		; On teste si le bit 0 = 1
	JP nc,Balayage33; Si le bit 0 = 0 on boucle jusqu'a la fin du balayage
			; On est en haut de l'ecran, on peut continuer le programme

	HALT 		; Attendre interruption 1
	HALT 		; Attendre interruption 2

	DI		; 1 nop
	NOP

	; Position vertical (141 coin haut gauche)
	;+8 pour ligne graphique suivante
	;+64 pour ligne texte suivante
	LD BC,141-8+64+8+8+8+8
.WaitLoop33
	NOP		; 1 nop
	DEC BC		; 2 nops
	LD A,B		; 1 nop
	OR C		; 1 nops
	JR NZ,WaitLoop33; 3 nops, TOTAL 8 nops



	; split colors (6 couleurs = 12 nops)
	LD b,&55	; bleu par defaut (2 nops)
	LD c,&40	; gris(2 nops)
	LD h,0		; (2 nops)
	LD l,0		; (2 nops)
	LD d,0		; (2 nops)
	LD e,0		; (2 nops)


	; Position horizontal (40 colonne, 1 nop par colonne)
	DEFS 53,0

;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;SPLIT-RASTERS 1
;8 nops invisible
	LD a,26	;nombre de ligne graphique	(2 nops)
		splitrasterligne331:
		DEFS 6,0
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 19,0
		OUT (c),c  ; 4 nops
		OUT (c),b  ; 4 nops
		DEFS 13,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 6,0
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne331	;3 nops

	
;SPLIT-RASTERS 2
;8 nops invisible
	LD a,26	;nombre de ligne graphique	(2 nops)
		splitrasterligne332:
		DEFS 5,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 16,0
		OUT (c),c  ; 4 nops
		DEFS 5,0
		OUT (c),b  ; 4 nops
		DEFS 11,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 7,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne332	;3 nops

	
;SPLIT-RASTERS 3
;8 nops invisible
	LD a,48	;nombre de ligne graphique	(2 nops)
		splitrasterligne333:
		DEFS 4,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 12,0
		OUT (c),c  ; 4 nops
		DEFS 12,0
		OUT (c),b  ; 4 nops
		DEFS 8,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 8,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne333	;3 nops
	

	;couleurs d'origine
	OUT (c),b  ; 4 nops


	EI		; 1 nop



; Test touche
.Touche33
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F645	;ligne 5
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche ESPACE)
JR NC,Sortir33
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F649	;ligne 9
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche DEL)
	RLA		;Charge dans A la valeur du bit 6 (touche JOY_FIRE0)
	RLA		;Charge dans A la valeur du bit 5 (touche JOY_FIRE1 Z)
	RLA		;Charge dans A la valeur du bit 4 (touche JOY_FIRE2 X)
	JP C,loop33	;Si TIR du joystick n'a pas etait enfonce on boucle



.Sortir33
	;retour au BASIC
	DI 		; Desactiver les interruptions
	LD HL,(Sauver) 	; Restauration des anciennes interruptions
	LD (&38),hl 	; Ecrire
	EI 		; Interruption autorisees
	RET

;----------------------------------------------------------------------------
;--- ECRAN 34 ---
;---------------
.ecran34
	XOR a
	LD bc,0
	CALL &BC32

	LD a,1
	LD bc,&0202
	CALL &BC32

	LD a,2
	LD bc,&0606
	CALL &BC32

	LD a,3
	LD bc,&1A1A
	CALL &BC32

	DI		; Desactiver les interruptions
	LD HL,(&38) 	; Lire l'ancienne interruption
	LD (Sauver),HL 	; Sauvegarder la valeur 16 bits
	LD HL,&C9FB 	; Registre 16 bits EI (&FB) + RET (&C9)
	LD (&38),HL 	; Ecrire en &0038 et &0039 le contenu du registre HL
	EI 		; Interruption autorisees

	;encre 0 - Noir
	LD BC,#7F00	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 1 - Bleu
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&55        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 2 - rouge vif
	LD BC,#7F02	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4C        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 3 - Blanc
	LD BC,#7F03	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4B        ; 2 nops
	OUT (c),a       ; 4 nops

.loop34

	;encre 2
	LD BC,#7F02	; 3 nops
	OUT (c),c	; 4 nops

	LD B,&F5 	; Se connecter au PPI/8255 port B accessible via &F5xx
.Balayage34
	IN A,(C) 	; Lire le contenu
	RRA 		; On teste si le bit 0 = 1
	JP nc,Balayage34; Si le bit 0 = 0 on boucle jusqu'a la fin du balayage
			; On est en haut de l'ecran, on peut continuer le programme

	HALT 		; Attendre interruption 1
	HALT 		; Attendre interruption 2

	DI		; 1 nop
	NOP

	; Position vertical (141 coin haut gauche)
	;+8 pour ligne graphique suivante
	;+64 pour ligne texte suivante
	LD BC,141
.WaitLoop34
	NOP		; 1 nop
	DEC BC		; 2 nops
	LD A,B		; 1 nop
	OR C		; 1 nops
	JR NZ,WaitLoop34; 3 nops, TOTAL 8 nops



	; split colors (6 couleurs = 12 nops)
	LD b,&4C	; rouge vif par defaut (2 nops)
	LD c,&4A	; jaune vif (2 nops)
	LD h,&53	; turquoise vif (2 nops)
	LD l,&5F	; bleu pastel (2 nops)
	LD d,0
	LD e,0


	; Position horizontal (40 colonne, 1 nop par colonne)
	DEFS 53,0

;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;SPLIT-RASTERS 1
;8 nops invisible
	LD a,24	;nombre de ligne graphique	(2 nops)
		splitrasterligne341:
		DEFS 6,0
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 21,0
		OUT (c),c  ; 4 nops
		DEFS 3,0
		OUT (c),b  ; 4 nops
		DEFS 8,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 6,0
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne341	;3 nops


;SPLIT-RASTERS 2
;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;8 nops invisible
	LD a,45	;nombre de ligne graphique	(2 nops)
		splitrasterligne342:
		DEFS 5,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 21,0
		OUT (c),c  ; 4 nops
		DEFS 5,0
		OUT (c),b  ; 4 nops
		DEFS 6,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 7,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne342	;3 nops

	
;SPLIT-RASTERS 3
;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;8 nops invisible
	LD a,59	;nombre de ligne graphique	(2 nops)
		splitrasterligne343:
		DEFS 4,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 25,0
		OUT (c),l  ; 4 nops
		DEFS 2,0
		OUT (c),b  ; 4 nops
		DEFS 5,0
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 8,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne343	;3 nops	
	
	
;SPLIT-RASTERS 4
;8 nops invisible + 4 nops border + 40 nops ecran normal + 4 nops border + 8 nops invisible = 64 nops

;8 nops invisible
	LD a,70	;nombre de ligne graphique	(2 nops)
		splitrasterligne344:
		DEFS 3,0	;-1 pour compenser le decalage
;4 nops border gauche
		OUT (c),b  ; 4 nops
;40 nops - ecran normal
		DEFS 16,0
		OUT (c),h  ; 4 nops
		DEFS 16,0
		OUT (c),b  ; 4 nops
;4 nops border droit
		OUT (c),b  ; 4 nops
;8 nops invisible
		DEFS 9,0	;+1 pour compenser le decalage
		;total 60 NOPS

;engendrera un decalage de 4 nops sur la prochaine boucle
		DEC a	; 1 nop
	jr nz,splitrasterligne344	;3 nops	

	OUT (c),b  ; couleur d'origine (4 nops)

	EI		; 1 nop



; Test touche
.Touche34
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F645	;ligne 5
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche ESPACE)
JR NC,Sortir34
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F649	;ligne 9
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche DEL)
	RLA		;Charge dans A la valeur du bit 6 (touche JOY_FIRE0)
	RLA		;Charge dans A la valeur du bit 5 (touche JOY_FIRE1 Z)
	RLA		;Charge dans A la valeur du bit 4 (touche JOY_FIRE2 X)
	JP C,loop34	;Si TIR du joystick n'a pas etait enfonce on boucle



.Sortir34
	;retour au BASIC
	DI 		; Desactiver les interruptions
	LD HL,(Sauver) 	; Restauration des anciennes interruptions
	LD (&38),hl 	; Ecrire
	EI 		; Interruption autorisees
	RET

;----------------------------------------------------------------------------
;--- ECRAN 35 ---
;---------------
.ecran35
	XOR a
	LD bc,0
	CALL &BC32

	LD a,1
	LD bc,&0606
	CALL &BC32

	LD a,2
	LD bc,&1414
	CALL &BC32

	LD a,3
	LD bc,&1A1A
	CALL &BC32

	DI		; Desactiver les interruptions
	LD HL,(&38) 	; Lire l'ancienne interruption
	LD (Sauver),HL 	; Sauvegarder la valeur 16 bits
	LD HL,&C9FB 	; Registre 16 bits EI (&FB) + RET (&C9)
	LD (&38),HL 	; Ecrire en &0038 et &0039 le contenu du registre HL
	EI 		; Interruption autorisees

	;encre 0 - Noir
	LD BC,#7F00	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&54        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 1 - Rouge
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4C        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 2 - Turquoise vif
	LD BC,#7F02	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&53        ; 2 nops
	OUT (c),a       ; 4 nops

	;encre 3 - Blanc
	LD BC,#7F03	; 3 nops
	OUT (c),c	; 4 nops
	LD a,&4B        ; 2 nops
	OUT (c),a       ; 4 nops

.loop35

	LD B,&F5 	; Se connecter au PPI/8255 port B accessible via &F5xx
.Balayage35
	IN A,(C) 	; Lire le contenu
	RRA 		; On teste si le bit 0 = 1
	JP nc,Balayage35 	; Si le bit 0 = 0 on boucle jusqu'a la fin du balayage
			; On est en haut de l'ecran, on peut continuer le programme


	HALT 		; Attendre interruption 1
	HALT 		; Attendre interruption 2

	;positionnement
	LD a,169
.decalage35
	DEFS 12,0		;4 nop
	DEC a			;1 nop
	JP nz,decalage35		;3 nops

	;ajustement
	DEFS 1

	;encre 1
	LD BC,#7F01	; 3 nops
	OUT (c),c	; 4 nops

	LD hl,table_rasters ; 3 nops
	LD e,total_raster   ; (nb de rasters a lire) 2 nops

.lire_couleur_raster
	LD a,(hl)                 ; 2 nops
	INC hl                    ; 2 nops
	OUT (c),a                 ; 4 nops

	;synchronisation (64 nops par ligne)
	defs 64-4-2-2-1-3

	DEC e                     ; 1 nops
	JP nz,lire_couleur_raster ; 3 nops

; Test touche
.Touche35
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F645	;ligne 5
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche ESPACE)
JR NC,Sortir35
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F649	;ligne 9
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche DEL)
	RLA		;Charge dans A la valeur du bit 6 (touche JOY_FIRE0)
	RLA		;Charge dans A la valeur du bit 5 (touche JOY_FIRE1 Z)
	RLA		;Charge dans A la valeur du bit 4 (touche JOY_FIRE2 X)
	JP C,loop35	;Si TIR du joystick n'a pas etait enfonce on boucle

.Sortir35
	;retour au BASIC
	DI 		; Desactiver les interruptions
	LD HL,(Sauver) 	; Restauration des anciennes interruptions
	LD (&38),hl 	; Ecrire
	EI 		; Interruption autorisees
	RET


total_raster EQU 1+12+18+47+40+14+22+1

.table_rasters
;noir (1)
DEFB &54
;rouge (12)
DEFB &4C,&4C,&4C,&4C,&4C,&4C,&4C,&4C,&4C,&4C,&4C,&4C
;violet (18)
DEFB &4D,&4D,&4D,&4D,&4D,&4D,&4D,&4D,&4D,&4D,&4D,&4D
DEFB &4D,&4D,&4D,&4D,&4D,&4D
;jaune (47)
DEFB &4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A
DEFB &4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A
DEFB &4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A
DEFB &4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A,&4A
DEFB &4A,&4A,&4A,&4A,&4A,&4A,&4A
;gris (40)
DEFB &40,&40,&40,&40,&40,&40,&40,&40,&40,&40
DEFB &40,&40,&40,&40,&40,&40,&40,&40,&40,&40
DEFB &40,&40,&40,&40,&40,&40,&40,&40,&40,&40
DEFB &40,&40,&40,&40,&40,&40,&40,&40,&40,&40
;vert vif (14)
DEFB &52,&52,&52,&52,&52,&52,&52,&52,&52,&52
DEFB &52,&52,&52,&52
;bleu (22)
DEFB &55,&55,&55,&55,&55,&55,&55,&55,&55,&55
DEFB &55,&55,&55,&55,&55,&55,&55,&55,&55,&55
DEFB &55,&55
;noir (1)
DEFB &54


;00 = &54 noir
;01 = &44 bleu
;02 = &55 bleu vif
;03 = &5C rouge fonce
;04 = &58 magenta
;05 = &5D mauve
;06 = &4C rouge vif
;07 = &45 pourpre
;08 = &4D magenta vif
;09 = &56 vert
;10 = &46 turquoise
;11 = &57 bleu ciel
;12 = &5E jaune
;13 = &40 gris
;14 = &5F bleu pastel
;15 = &4E orange
;16 = &47 rose
;17 = &4F magenta pastel
;18 = &52 vert vif
;19 = &42 vert marin
;20 = &53 turquoise vif
;21 = &5A vert citron
;22 = &59 vert pastel
;23 = &5B turquoise pastel
;24 = &4A jaune vif
;25 = &43 jaune pastel
;26 = &4B blanc

;------------------------------------------------------------------------------
;list
; Aplib decrunching routine
;nolist
; (c) CNGSOFT
; En entree, on a :
; HL = implantation du code compacte
; DE = implantation du code decompacte
;------------------------------------------------------------------------------
DECOMPECRAN
	;DI
        ;LD HL,CHOIXECRAN
        ;LD DE,&C000

        CALL boot
        JP &000F

; Maxam source by T&J/GPA -  01/18/2008
; Nothing changed, except thy damned hidden opcodes
; and a new variable for Maxam ( 13+8*0 = 0 for Maxam )
; Attention, cette routine contient un assemblage conditionnel.
; Si Aplib8flag = 0, le code decompacte est ecrite du bas de la
; memoire vers le haut de la memoire. C est ce que font par defaut
; les programmes modifies par Dadman/CEZ - Team (APPACK.EXE et
; aPPackWin.exe.

; Si Aplib8flag = 1, le code decompacte est ecrit du haut de la
; memoire vers le bas de la memoire. Le code compacte doit bien
; evidemment etre organise en consequence.
aplib8flag equ &0  ; = DEC  &00 pour INC

flagdecde equ aplib8flag*8 ; for Maxam compatibility

Boot
 PUSH HL ; used for EX HL,(SP)
 PUSH HL
  POP IX
 DB &FD,&26,&80 ; LD IYh,&80
  
aplib8literal

 LD A,(IX+ &00)

 DB &DD,&23 + flagdecde ; INC IX/DEC IX
 
 LD (DE),A
 
 DB &13 + flagdecde ; INC DE/DEC DE
 DB &FD,&2E,&02       ; LD IYl,&2

aplib8nexttag

 CALL aplib8getbit
  JR NC, aplib8literal
 LD BC,&0000
 CALL aplib8getbit
 JR NC, aplib8codepair
 LD H,B
 CALL aplib8getbit
 JR NC, aplib8shortmatch
 DB &FD,&2E,&02      ; LD IYl,2
 INC C ; bc
 LD L,&10

aplib8getmorebits

 CALL aplib8getbit
 RL L
 JR NC, aplib8getmorebits
 JR NZ, aplib8domatch
  LD A,L
 LD (DE),A
 DB &13+ flagdecde ; INC DE/DEC DE
 JR aplib8nexttag

aplib8codepair
 
 CALL aplib8getgamma
  DB &FD,&4D  ; LD C,IYl
 SBC HL,BC
  JR NZ, aplib8normalcodepair
 CALL aplib8getgamma
  LD B,H
 JR aplib8domatch_lastpos

aplib8normalcodepair

 DEC L
 LD H,L
  LD L,(IX + &00)
 DB &DD,&23+ flagdecde ; INC IX/DEC IX
  PUSH HL
 CALL aplib8getgamma
 LD B,H
  POP HL
 LD A,H
 CP 125 ; cmp eax,32000
  JR NC, aplib8domatch_with_2inc
 CP &05
  JR NC, aplib8domatch_with_inc
 AND A
  JR NZ, aplib8domatch_new_lastpos
 LD A,L
  ADD A
 JR C, aplib8domatch_new_lastpos

aplib8domatch_with_2inc 

 INC BC
 
aplib8domatch_with_inc

 INC BC
aplib8domatch_new_lastpos

 EX (SP),HL
 
aplib8domatch_lastpos

 POP HL
 PUSH HL
  DB &FD,&2E,&01  ; LD IYl,1

aplib8domatch

if aplib8flag ; LDIR/LDDR

  ADD HL,DE
   LDDR
else
 AND A
  EX DE,HL
   SBC HL,DE
   EX DE,HL
   ADD HL,DE
 EX DE,HL
  LDIR
endif
 JR aplib8nexttag

aplib8shortmatch

 LD L,(IX+&00)
 DB &DD,&23+ flagdecde ; INC IX/DEC IX
  SRL L
 JR Z, aplib8donedepacking
  RL C
 JR aplib8domatch_with_2inc

aplib8getbit

 DB &FD,&7C ; LD A,IYh
 ADD A
  JR NZ,aplib8getbit_
  LD A,(IX + &00)
 DB &DD,&23+ flagdecde ; INC IX/DEC IX
  ADC A

aplib8getbit_

 DB &FD,&67 ; LD  IYh,A
 RET

aplib8getgamma

 LD HL,&0001
 
aplib8getgamma_ 
 CALL aplib8getbit
 ADC HL,HL
  CALL aplib8getbit
 JR C, aplib8getgamma_
  LD C,L
 RET

aplib8donedepacking

 POP HL ; used for EX HL,(SP)
 PUSH IX
  POP HL
 RET ; Warning, A might not be 0!